* IO model for test with 36 sectors
*  Cobb=Douglas production function for test -- should be replaced by CES type
* 3 new ICT services added 20200926
* coefficients of new ICT sectors assumed same to section 29 information and communication sector
* MaaS car sharing only ; modified 2020 10 1
* HEV-PIHV-EV-CEV and ZEHready-ZEH added 2020 10 12
* Step-4 passenger car expenditure fixed
* MaaS coeff fixed
* MaaS car sharing including fuel costs
* CES production
* water transport sector output modified
* freight transportation sectors modified
* iron and steel industry expanded 20201027
* SaaS parameter modified
* construction sector future stock and depreciation rate modified
* 20201210 Fossil fuel for industry scenario -- H2, wood-chip and electrification
* 20201211 relative price balance imposed
* 20201215 LCS power scenario
* 20201216 relative price for power sector revised
* export limit
* 20210107 SaaS productivity upper limit LbrAug.UP(j)=1.25 for all sectors
* 2021 4 5 expansion in power sector -- construction of power sector added
* 2021 4 15 electricity price reintroduced
* 2021 4 20 technology scenario in Step-3 divided into demand-side and supply-side
* Step-1  2015 initial solution
* Step-2  2030 BAU solution
* Step-3  2030 ZEH, EV
* Step-4  Step-3 + MaaS, SaaS, Infs
* Step-5  Step-4 + LCS power sector scenario
* Step-6  Step-5 + iron and steel industry
* Step-7  Step-6 +industry sector H2 + electrification
* 20210421 gas price modified
* fuel consumption in power sector in Scenario 5,6,7 fixed
* trade expansion limited -- factor 10 to factor 3
* expecting lower economic growth behavior scenario
* gas average price with H2 revised
* gas and elec for final demand revised
* capital growth scenario modified
* expanded 105 -> 133 sectors
* export-import balance introduced
* deterioration rate of EFC modified
* 2030 -> 2050
* 20220716 variable yields of oil products
* minimization of export of fossil fuel products
* 20220816 FC-FCV and hydrogen production added
* 20220729 RaaS sector added
* 20220805 revise capital formation
* 20220816 modify distribution of VAD
* 20220910 modify RaaS capital formation

***============================

FILE FSAVE /MIO135_2050_i_tl.CSV/;
PUT FSAVE;
FSAVE.PC=5;
FSAVE.PW=4096;

* all column sectors -- sector aggregated 35 oil products

set j_AL /1*5, 6a, 6b, 6c,7a,7b, 8*35, 35_a, 35_b,35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*47, SCRP_s, 48*53, SCRP_n, 54*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2, Clm_T, Csp_Prv, Csp_Gov, Csp_Oth, CpF_Prv, CpF_Gov, CpF_Oth, Fnd_T, DmDmd, Exp, Imp, Q_Clm_T/;

* productioln sectors with PRDFs

set j_TL(j_AL) /1*5, 6a,6b,6c,7a,7b,8*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2, Clm_T, Csp_Prv, Csp_Gov, Csp_Oth, CpF_Prv, CpF_Gov, CpF_Oth, Fnd_T, DmDmd, Exp, Imp, Q_Clm_T/;

* independent sectors
set clm(j_TL) /1*5, 6a,6b,6c,7a,7b,8*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2, Csp_Prv, Csp_Gov, Csp_Oth, CpF_Prv, CpF_Gov, CpF_Oth, Exp, Imp/;

* endogenous sectors with production funcltions
set j(clm) /1*5, 6a,6b,6c,7a,7b,8*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2/;

set csp(clm) /Csp_Prv, Csp_Gov, Csp_Oth/;
set cpf(clm) /CpF_Prv, CpF_Gov, CpF_Oth/;
set trd(clm) /Exp, Imp/;

* existing column sectors
set j_15(j)  /1*5, 6a,6b,6c,7a,7b,8*88, EFC, 89*128/;

* final demand
set j_Fnd(j_TL) /Csp_Prv, Csp_Gov, Csp_Oth, CpF_Prv, CpF_Gov, CpF_Oth, Exp, Imp/;

* information service row sectors
set j_50(j)     /SaaS, MaaS, InfS, RaaS, H2/;
set j_30(j_50)  /SaaS, MaaS, InfS, RaaS/;

* all row sectors
set i_TL /1*5, 6a, 6b, 6c,7a,7b, 8*34, 35_a, 35_b,35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*47, SCRP_s, 48*53, SCRP_n, 54*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2, Row_T, Wage, Rtrn, Othrs, Vad_T, Q_Row_T/;

* row independent products
set row(i_TL) /1*5, 6a, 6b, 6c,7a,7b, 8*34, 35_a, 35_b,35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*47, SCRP_s, 48*53, SCRP_n, 54*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2, Row_T, Wage, Rtrn, Othrs/;

* row endogenous products
set i(Row) /1*5, 6a, 6b, 6c,7a,7b, 8*34, 35_a, 35_b, 35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*47, SCRP_s, 48*53, SCRP_n, 54*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2/;

set i_OPs(i) /35_a, 35_b,35_c,35_d,35_e,35_f,35_g,35_h,35_i/;

* products without scraps

set i_Prd(i) / 1*5, 6a, 6b, 6c,7a,7b, 8*34, 35_a, 35_b, 35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2/;

set i_SCRP(i) /SCRP_S, SCRP_N/;

set i_nScrp(i) /1*5, 6a, 6b, 6c,7a,7b, 8*34, 35_a, 35_b, 35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*88, EFC, 89*128, SaaS, MaaS, InfS, RaaS, H2/;

alias (i,ii);

* existing products
set i_15(i) /1*5, 6a, 6b, 6c,7a,7b, 8*34, 35_a, 35_b,35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*47, SCRP_s, 48*53, SCRP_n, 54*88, EFC, 89*128/;

* ICT services
set i_50(i) /SaaS, MaaS, InfS, Raas, H2/;
set i_30(i_50) /SaaS, MaaS, InfS, RaaS/;

set i_UP(i) no expansion /45*47/;

* 2020 11 27 stock upper limit on construction sector
set j_Bld(j) stock expansion limit for building sectors /87, 96/;
set j_Nbld(j) non-building sectors  /1*5, 6a,6b,6c,7a,7b,8*86, 88, EFC, 89*95, 97*128, SaaS, MaaS, InfS, RaaS, H2/;

* 2020 10 20 water transportation and ship building limited

set i_LMT(i) output expansion limit /81, 100/;

* 2021 4 23  SaaS for all sectors

set j_SAS(j) /1*5, 6a,6b,6c,7a,7b,8*88, EFC, 89*128/
    j_NSas(j) /SaaS, MaaS, Infs, RaaS, H2/;

* 20220729
 set j_RaS(j)  /1*5, 8*18, 40, 54*88, EFC, 89*128/
     j_NRaS(j) /6a,6b,6c,7a,7b, 18*39,  41*53/;

set j_LELS(j) /6a, 6b, 6c,7a,7b, 8*88, EFC, 89*92,H2/;
set j_prm(j)  primary industry /1*5/;

* 20201217 export limitation

set i_dms(i) /3, 84*88, EFC, 89*92, 96, 107, 111, 114*119, 123, 125,126/;

* 2021 4 24 constant public investment
set j_infr(j) /85,87, 91, 92/;

* 20210415 new formulation on power sector

set j_El(j)  /EFC, 89/
    j_Nel(j) /1*5, 6a,6b,6c,7a,7b,8*88, 90*128, SaaS, MaaS, InfS, RaaS, H2/
;

set Vad(row) /Wage, Rtrn, Othrs/;
set Vkl(row) /Wage,Rtrn/;

* 2020 10 12 automobile sector HEV-PIHV-EV-CEV

set VCLE      /ICE, HV, PHV, EV, CEV/;
set XEV(VCLE) /HV, PHV, EV, CEV/;

* 2020 10 12 ZEH Old-ZEHr-ZEH

set RSB /OLD, ZEHrd, ZEH/;

* 20201023  freight transportation scenario

set FR_tr(j) /79,99/;

* 20201027 iron and steel

set irstl(j) /45,46,47/;
set fnc /blf, elf, oth/;

*  20201205 electrification for industry sectors
*  chemical, iron, automobile, residential sectors should be excluded

set j_elfy(j) /1*5,6a,6b,6c,7a,7b,8*18, 37*43, 53*77, 80*88, EFC, 91*98, 102*128/;

Scalar Sh_Elfy  elctrification /0.333/;
Parameter R_Elfy(j);
 R_Elfy(j)=Sh_Elfy;

** 2020 12 11 hydrogen burner for industry

set j_Hydro(j) /8*17, 37*43, 53*83, 85*88, EFC/;

* 133 -- j_TL -> J_AL
Table MIO_i(i_TL, j_AL)
$call=xls2gms r=C3:EQ151 i=IO2015_135_2050_Dat.xlsx o=MIOX.inc
$include MIOX.inc
;

* initial yield rates of oil products
Parameter Oprd_Yld(i_TL);

MIO_i(i_TL, j_AL)=MIO_i(i_TL, j_AL)/1e6;

Scalar OPs_Wrk;

OPs_Wrk=sum(i_OPs, MIO_i(i_OPs, "Q_Clm_T"));

Oprd_Yld(i_OPs)=MIO_i(i_OPs, "Q_Clm_T")/OPs_Wrk;

display Oprd_Yld;

** 20220622 modified

Table ijcnv(i,j)
$call=xls2gms r=B2605:EG2750 i=IO2015_135_2050_Dat.xlsx o=ijcnvX.inc
$include ijcnvX.inc
;

ijcnv("RaaS","RaaS")=1;
ijcnv("H2","H2")=1;

** 2023 5 17 revised

parameter ijcnv2(i,j);

ijcnv2(i,j)=0.0;
ijcnv2(i,j)$(ijcnv(i,j) gt 0.0)=1.0;


Table CpfMtx(i,j)
$call=xls2gms r=C157:EF207 i=IO2015_135_2050_Dat.xlsx o=CPFX.inc
$include CPFX.inc
;

CpfMtx(i,j)=CpfMtx(i,j)/1e6;

display Cpfmtx;

Parameter Lbr_i(j)
/
$call=xls2gms r=C212:D343 i=IO2015_135_2050_Dat.xlsx o=LBRX.inc
$include LBRX.inc
/
;

Lbr_i(j)=Lbr_i(j)/1000.;

Parameter Dlt_i(j)
/
$call=xls2gms r=C348:D479 i=IO2015_135_2050_Dat.xlsx o=DLTX.inc
$include DLTX.inc
/
;

** assumption on ICT

Dlt_i(j_30)=Dlt_i("108");
Dlt_i("H2")=Dlt_i("90");

Dlt_i("MaaS")=Dlt_i("119");

Parameter Y_els(i)
/
$call=xls2gms r=C485:D626 i=IO2015_135_2050_Dat.xlsx o=YELSX.inc
$include YELSX.inc
/
;

Table AIO_50(i_TL, j_50)
$call=xls2gms r=C631:H779 i=IO2015_135_2050_Dat.xlsx o=AIO50X.inc
$include AIO50X.inc
;

* 20220729

** IO coeff. of new vehicles 2020 10 12

Table AIO_VCL(i_TL, VCLE)
$call=xls2gms r=C784:H931 i=IO2015_135_2050_Dat.xlsx o=AIOVCLX.inc
$include AIOVCLX.inc
;

* price of vehicles in producer price
Parameter P_vcl(VCLE)
/
$call=xls2gms r=B937:C941 i=IO2015_135_2050_Dat.xlsx o=VCLX.inc
$include VCLX.inc
/
;

Parameter Pi_vcl(VCLE);
 Pi_vcl(VCLE)= P_vcl(VCLE)/ P_vcl("ICE");

* 20220713 2030 -> 2050

* VCLE stock share in 2050
Parameter StkSh_v50(VCLE)
/
$call=xls2gms r=B946:C950 i=IO2015_135_2050_Dat.xlsx o=StkVS50X.inc
$include StkVS50X.inc
/
;

* VCLE sales share in 2050
Parameter SlsSh_v50(VCLE)
/
$call=xls2gms r=B954:C958 i=IO2015_135_2050_Dat.xlsx o=SlSVS50X.inc
$include SlSVS50X.inc
/
;

* VCLE sales share in 2020
Parameter SlsSh_v20(VCLE)
/
$call=xls2gms r=B962:C966 i=IO2015_135_2050_Dat.xlsx o=SlSVS20X.inc
$include SlSVS20X.inc
/
;

Scalars
  VclStk_50   in million /44.314/
  VclStk_30   in million /54.734/
  VclStk_15  in million  /60.987/

  VclSls_30   in million /4.781/
  VclSls_50   in million /3.860/
;

* VCLE Oil cost reduction Myen per ICE Myen
Parameter Oil_Rdc(VCLE)
/
$call=xls2gms r=B970:C974 i=IO2015_135_2050_Dat.xlsx o=OilRdcX.inc
$include OilRdcX.inc
/
;

* VCLE Elc cost increase  Myen per ICE Myen
Parameter Elc_Inc(VCLE)
/
$call=xls2gms r=B979:C983 i=IO2015_135_2050_Dat.xlsx o=ElcIncX.inc
$include ElcIncX.inc
/
;

** Capital coeff. of houses 2020 10 12
Table CpCof_H(i, Rsb)
$call=xls2gms r=C987:F1037 i=IO2015_135_2050_Dat.xlsx o=CpfRsbX.inc
$include CpfRsbX.inc
;

* price index of houses in producer price
Parameter Pi_rsb(Rsb)
/
$call=xls2gms r=B1044:C1046 i=IO2015_135_2050_Dat.xlsx o=PrsbX.inc
$include PrsbX.inc
/
;

* Stock share of houses in 2030
Parameter Sh_Srsb(Rsb)
/
$call=xls2gms r=B1050:C1052 i=IO2015_135_2050_Dat.xlsx o=ShRsbSX.inc
$include ShRsbSX.inc
/
;

* Sales share of houses in 2030
Parameter Sh_Nrsb(Rsb)
/
$call=xls2gms r=B1056:C1058 i=IO2015_135_2050_Dat.xlsx o=ShRsbNX.inc
$include ShRsbNX.inc
/
;

* ratio of new houses to total stock
* Scalar NwSt_Rto 2030 /0.014053/;
 Scalar NwSt_Rto  2050 /0.01041/;

* Energy demand ratio ; old house based
Parameter GasRtio(Rsb)
/
$call=xls2gms r=B1067:C1069 i=IO2015_135_2050_Dat.xlsx o=GasRtoX.inc
$include GasRtoX.inc
/
;

Parameter ElcRtio(Rsb)
/
$call=xls2gms r=B1072:C1074 i=IO2015_135_2050_Dat.xlsx o=ElcRtoX.inc
$include ElcRtoX.inc
/
;

** Car-sharing company capital coeff 2020 10 15
Table CpCof_CaS(i, VCLE)
$call=xls2gms r=B1078:D1220 i=IO2015_135_2050_Dat.xlsx o=CpfCarSX.inc
$include CpfCarSX.inc
;

** Car-sharing company capital coeff 2020 10 15
Table AIO_CaS(i_TL, VCLE)
$call=xls2gms r=B1225:D1373 i=IO2015_135_2050_Dat.xlsx o=AIOCarSX.inc
$include AIOCarSX.inc
;

** freight transportation sectors modified for 2030

Table AIO_FRV(i_TL, Fr_tr)
$call=xls2gms r=C1376:E1523 i=IO2015_135_2050_Dat.xlsx o=AIOfrtrX.inc
$include AIOfrtrX.inc
;

Parameter VAIO_FRV(i_tl, Fr_tr);

VAIO_FRV(i, Fr_tr)=AIO_FRV(i, Fr_tr)/AIO_FRV("Vad_T", Fr_Tr);

** iron and steel industry expanded 20201027 removed in 133 model
* Table AIO_STL(i_TL, fnc)
* $call=xls2gms r=a1321:D1432 i=IO2015_105_T.xlsx o=AIOSTLX.inc
* $include AIOSTLX.inc
* ;

** capital stock to investment ratio modified 20201202

Parameter CPS_InV_R(j)
/
$call=xls2gms r=C1526:D1657 i=IO2015_135_2050_Dat.xlsx o=CpsInvX.inc
$include CpsInvX.inc
/;


** 20201205 electrification for all sectors other than iron, vehicle and residential buildings
* removed in 133 model
* 20201210 capital formation coeffs for hydrogen production by electrolysis

Parameter CPF_H2(i)
/
$call=xls2gms r=C1661:D1710 i=IO2015_135_2050_Dat.xlsx o=CPF_H2X.inc
$include CPF_H2X.inc
/
;

* price ratio H2 to City gas
* 2021 4 26 industry demand share introduce

Scalar
 H2_CG_Rto   /3.071890538/
 Gs_Ind_Sh   /0.640/
;

Parameter AIO_H2(i_TL)
/
$call=xls2gms r=C1718:D1864 i=IO2015_135_2050_Dat.xlsx o=AIO_H2X.inc
$include AIO_H2X.inc
/
;

* 20201215 power industry for LCS-2030

Parameter LCS_EL_AIO(i_TL)
/
$call=xls2gms r=C2267:D2414 i=IO2015_135_2050_Dat.xlsx o=AIO_PwrX.inc
$include AIO_PwrX.inc
/
;

Parameter LCS_EL_Cpf(i)
/
$call=xls2gms r=C2418:D2467 i=IO2015_135_2050_Dat.xlsx o=CPF_PwrX.inc
$include CPF_PwrX.inc
/
;

* 2021 4 15 overall electric price ratio

Scalar NwElc_PR /1.024/;


Scalar ShrLCS /1.0/;

Parameter ICT_PRDupf(j)
/
$call=xls2gms r=C2470:D2601 i=IO2015_135_2050_Dat.xlsx o=SaaSPrdX.inc
$include SaaSPrdX.inc
/;

Parameter OilPrc(i_Ops)
/
$call=xls2gms r=C3254:D3262 i=IO2015_135_2050_Dat.xlsx o=OilPrd_PrX.inc
$include OilPrd_PrX.inc
/;


Parameter Ras_Prdupf(j)
/
$call=xls2gms r=C3471:D3602 i=IO2015_135_2050_Dat.xlsx o=RaaSPrdX.inc
$include RaaSPrdX.inc
/;

** 20220910 RaaS capital coeffs
Parameter RaS_Cpf(i)
/
$call=xls2gms r=C3605:D3655 i=IO2015_135_2050_Dat.xlsx o=RaaSCpfX.inc
$include RaaSCpfX.inc
/;

** check MIO_i original
Put //;

Put "","MIO_i(i,j) initial"/;
Put "",""; loop(j_TL, put j_TL.TL);Put /;
Loop(i_TL,
  Put "",i_TL.TL;
  Loop(j_TL, Put MIO_i(i_TL, j_TL):15:5 );
     Put /;
);
Put //;


Parameters
 VAIO_0(i,j)
 PCLM_wrk0(j)
 PCLM_wrk1(j)

 P_clmw(j)
;

Scalar pwrk;

* iron and steel industry removed in model 133

** MaaS modified
Scalar MaaS_ICE_S /0.1/;

AIO_50(i_TL, "MaaS")=MaaS_ICE_S*AIO_CaS(i_TL, "ICE")+(1.0-MaaS_ICE_S)*AIO_CaS(i_TL, "EV");

parameter MIO(i_TL, j_AL);
 MIO(i_TL, j_AL)=MIO_i(i_TL, j_AL);

MIO("Vad_T",j)=sum(Vad, MIO_i(Vad, j));
MIO("Q_Row_T",j)=sum(i, MIO_i(i, j))+MIO_i("Vad_T",j);

MIO(i, "Clm_T")=sum(j, MIO_i(i,j));
MIO(i, "FND_T")=sum(csp, MIO_i(i,csp))+sum(cpf, MIO_i(i,cpf));
MIO(i, "DmDmd")=MIO(i, "Clm_T")+MIO(i, "FND_T");

MIO(i, "Q_Clm_T")=sum(j, ijcnv(i,j)*MIO("Q_Row_T",j) );


Scalar TTL_Vad_i;
 TTL_Vad_i=sum(j, MIO("Vad_T",j) );

Scalar P_LBR_T;
 P_LBR_T=sum(j, MIO("WAGE",j))/sum(j, Lbr_i(j));

** relative wage
Parameter P_Lbr(j);
P_Lbr(j)$(Lbr_i(j) gt 0)=MIO("WAGE",j)/Lbr_i(j)/P_LBR_T;
P_Lbr(j_30)=P_Lbr("29");
P_Lbr("H2")=P_Lbr("90");

display P_LBR_T, LBr_i, P_Lbr;

** check error
parameter RwWrk(i),ClWrk(j),Invst_i(j);

ClWrk(j)=MIO("Vad_T", j);

display ClWrk;

Clwrk(j)=sum(i, cpfmtx(i,j));
Invst_i(j)=sum(i, cpfmtx(i,j));

display ClWrk;

**  20220805 modify capital formation
** share between capital formation sectors

 Parameter CPfShrs(i, cpf);
  CPfShrs(i, cpf)=0.0;
  RwWrk(i)=MIO(i, "Cpf_prv") + MIO(i, "Cpf_Gov");
  CPfShrs(i, "Cpf_prv")$(RwWrk(i) gt 0)=MIO(i, "Cpf_prv")/RwWrk(i);
  CPfShrs(i, "Cpf_gov")$(RwWrk(i) gt 0)=MIO(i, "Cpf_gov")/RwWrk(i);

 RwWrk(i_nScrp)=sum(cpf, MIO(i_nScrp,cpf));
 MIO(i_nScrp, "CpF_Prv")=sum(j_15, CpfMtx(i_nScrp,j_15))*CPfShrs(i_nScrp, "Cpf_prv");
 MIO(i_nScrp, "CpF_Gov")=sum(j_15, CpfMtx(i_nScrp,j_15))*CPfShrs(i_nScrp, "Cpf_gov");

 MIO(i_nScrp, "CpF_Oth")=RwWrk(i_nScrp)-MIO(i_nScrp, "CpF_Prv")-MIO(i_nScrp, "CpF_Gov");

 RwWrk(i_nScrp)=MIO(i_nScrp, "DmDmd")+sum(trd, MIO(i_nScrp,trd)) - MIO(i_nScrp, "Q_Clm_T");

display RwWrk;

** check MIO adjusted
Put //;

Put "","MIO(i,j) initial"/;
Put "",""; loop(j_TL, put j_TL.TL);Put /;
Loop(i_TL,
  Put "",i_TL.TL;
  Loop(j_TL, Put MIO(i_TL, j_TL):15:5 );
     Put /;
);
Put //;


Parameter AIO(i_TL,j_AL), VAIO(i_TL,j);

 AIO(i_TL,j_AL)$(MIO("Q_Row_T",j_AL) gt 0)=MIO(i_TL,j_AL)/MIO("Q_Row_T",j_AL);
 VAIO(i,j)$(MIO("VAD_T",j) gt 0)=MIO(i,j)/MIO("VAD_T",j);

** 2020 9 26
 AIO(i_TL,j_50)=AIO_50(i_TL, j_50);

 MIO(i_TL,j_50)=AIO_50(i_TL, j_50);
 VAIO(i,j)$(MIO("VAD_T",j) gt 0)=MIO(i,j)/sum(vad, MIO(vad,j));

* setting of production function coefficients for Cobb=Douglas function
* should be modified afterwards

Scalar DscRte /0.05/
       Yftr   /35/
;

Parameter K_shr(j),K0(j);

ClWrk(j)=MIO("Vad_T", j);

display ClWrk;

** estimating initial value of capital stock 20201202 modified
* revised based on SNA 2013-2018
* modified  SNA on@2015-2018

parameter cptl_Stk_g(j)
/
$call=xls2gms r=C2753:D2888 i=IO2015_135_2050_Dat.xlsx o=CpStkX.inc
$include CpStkX.inc
/
;


 parameter Cps_G(j);
 Scalar YrEst /5/;

 Cps_g(j) =cptl_Stk_g(j) **YrEst;

 Cps_g(j_bld) = 1.0;

 K_shr(j)=1.0-MIO("Wage",j)/MIO("Vad_T",j);

 K0(j)=(1.0-(1.0-Dlt_i(j))**YrEst)/Dlt_i(j)*Invst_i(j)/(Cps_g(j) - (1.0-Dlt_i(j))**YrEst);

* 20220910
 K0("RaaS")=K0("67")*2.163;

* 20220620 modified

 K0(j)$(k0(j) le 0)=CPS_InV_R(j)*Invst_i(j);
 K0(j_prm)=CPS_InV_R(j_prm)*Invst_i(j_prm);

** 2020 12 15 power industry modified

 k0("89")=77.7;


display K0, Dlt_i, Invst_i, Cps_g;

** tentative setting on labor input for 3 ICT services
* 108 information service

 Lbr_i(j_50)=MIO("Wage", j_50)/(MIO("WAGE","108")/Lbr_i("108"));
 Lbr_i("H2")=MIO("Wage", "90")/(MIO("WAGE","90")/Lbr_i("90"));
 Lbr_i("RaaS")=MIO("Wage", "67")/(MIO("WAGE","67")/Lbr_i("67"));

** 2020 10 15 CES production function
* 0.3 -> 0.6

Scalars
 KL_ELS0 /0.6/
;

Parameter KL_ELS(j), KLBT(j), AY(j), BY(j), PKY(j), PLY(j);

  KL_ELS(j)=KL_ELS0;

  KL_ELS(j_LELS)=0.25;

  KLBT(j)=-(1.0/KL_ELS(j)-1.0);

  BY(j)$(k0(j) gt 0)=(1.0-K_shr(j))/K_shr(j)*(Lbr_i(j)/K0(j))**(-KLBT(j));

  ClWrk(j)$(k0(j) gt 0)=(K0(j)**KLBT(j) + BY(j)*Lbr_i(j)**KLBT(j))**(1.0/KLBT(j));
  AY(j)$(k0(j) gt 0)=MIO("Vad_T",j)/ClWrk(j);

  Clwrk(j)$(k0(j) gt 0)=AY(j)*( (K0(j)+1e-5)**KLBT(j) + BY(j)*(Lbr_i(j)+1e-5)**KLBT(j))**(1.0/KLBT(j));

  PKY(j)$(K0(j) gt 0)= MIO("Rtrn", j)/k0(j);
  PLY(j)$(Lbr_i(j) gt 0)= MIO("Wage", j)/Lbr_i(j);

  AY("SaaS")=AY("108");
  BY("SaaS")=BY("108");
  PKY("SaaS")=PKY("108");
  PLY("SaaS")=PLY("108");
  KLBT("SaaS")=KLBT("108");

  AY("InfS")=AY("108");
  BY("InfS")=BY("108");
  PKY("InfS")=PKY("108");
  PLY("InfS")=PLY("108");
  KLBT("InfS")=KLBT("108");

  AY("H2")=AY("90");
  BY("H2")=BY("90");
  PKY("H2")=PKY("90");
  PLY("H2")=PLY("90");
  KLBT("H2")=KLBT("90");

display AY, BY, ClWrk, k0, Lbr_i, PKY, PLY;

* reset new ICT sectors

Lbr_i(j_50)=0.0;
K0(j_50)=0.0;

* import coefficients and import coeffcients

Parameter ImCoef(i), ExCoef(i), VadShr(vad, j);
  ImCoef(i)=0.0;
  ExCoef(i)=0.0;

  ImCoef(i)$(MIO(i, "DmDmd") gt 0) = - MIO(i,"imp")/MIO(i, "DmDmd");
  ExCoef(i)$(MIO(i, "Q_Clm_T") gt 0) = MIO(i, "exp")/MIO(i, "Q_Clm_T");
  VadShr(vad, j)=MIO(vad,j)/MIO("Vad_T",j);

* capital formation coefficients

Parameter CpfCof(i,j);
 Invst_i(j_15)=sum(i, CpfMtx(i,j_15));
 CpfCof(i,j_15)=CpfMtx(i,j_15)/Invst_i(j_15);

display Invst_i;

 Invst_i(j_50)=0.0;

 CpfCof(i,"SaaS")=CpfCof(i,"108");
 CpfCof(i,"InfS")=CpfCof(i,"108");

 CpfCof(i,"MaaS")=MaaS_ICE_S*CpCof_CaS(i, "ICE")+ (1.0-MaaS_ICE_S)*CpCof_CaS(i, "EV");

* 20220723
 CpfCof(i,"H2")=CPF_H2(i);

* 20220910
  CpfCof(i,"RaaS")=Ras_Cpf(i);

* backup orgiginal initial data

Parameters AIO_org(i,j), VAIO_org(i,j), CpCf_org(i,j), MIO_org(i_TL, j_TL);
AIO_org(i,j)=AIO(i,j);
VAIO_org(i,j)=VAIO(i,j);
CpCf_org(i,j)=CpfCof(i,j);
MIO_org(i_TL, j_TL)=MIO(i_TL, j_TL);


* labor supply

Scalar Lbr_sup;

Lbr_sup=sum(j, Lbr_i(j) );

Put "Initial data check"/;
Put "","CpfMtx(i,j)"/;
Put "",""; loop(j, put j.TL);Put /
Loop(i,
  Put "",i.TL;
  Loop(j, Put CpfMTX(i,j):15:5 );Put /;
);

Put //;
Put "","LBR_i(j)"/;
Put "",""; loop(j, put j.TL);Put /
Put "","initial labor";
  Loop(j, Put LBR_i(j):15:5 );Put /;

Put //;
Put "","Dlt_i(j)"/;
Put "",""; loop(j, put j.TL);Put /
Put "","Deterioration";
  Loop(j, Put Dlt_i(j):15:5 );Put /;

Put //;

Put "","MIO(i,j) initial"/;
Put "",""; loop(j_TL, put j_TL.TL);Put /;
Loop(i_TL,
  Put "",i_TL.TL;
  Loop(j_TL, Put MIO(i_TL, j_TL):15:5 );
     Put /;
);
Put //;

Put "Vaio(i,j) initial"/;
Put "",""; loop(j, put j.TL);Put /
Loop(i,
  Put "",i.TL;
  Loop(j, Put Vaio(i, j):15:5 );
     Put /;
);
Put //;

** step-1 initial solution

Positive variables
 X_Clm(j)
 X_Row(i)

 T_Vad(j)

 X_ex(i)
 X_im(i)
 Invst(j)

 KY(j)
 LY(j)

 TL_VAD
;

Variables
 XAij(i,j)
 X_Ddmd(i)

 FD_Csp(i,csp)
 FD_Cpf(i,cpf)

 Y_Vad(vad,j)

 Ex_XAij(i,j)

 Vad_SLK(j)

* 20220703 flexibility for oilproducts
 X_FLX(i)
;

 X_FLX.FX(i)=0.0;

* 2020 10 16 share of capital and wage according to CES function

Variables
  Vad_sh(vad, j)
;

Equations

 XAIJ_def(i,j)
 X_ddmd_df(i)  domestic demand definition

 M_Clm_Bal(j)
 M_Row_bal(i)
 R_C_bal(i)

* P_RC_bal(i)

 VAD_Def(j)     production function
 TL_VAD_def

 Vad_Shr_df(vad, j)   value added sector definition

 Prv_Cpf_df(i)         private sector capital formation definition
 Gov_Cpf_df(i)         governmental sector capital formation definition

 Gov_CSP_df(i)         governmental sector consumption definition
 Oth_CSP_df(i)         other sector consumption definition

 exp_df_L(i)             export definition -- should be discussed further
 exp_df_U(i)             export definition -- should be discussed further
 imp_df(i)             import definition based on (I-M)- model

 LBR_UP
;

* 2020 12 11 relative price imposed 2020 12 12 variable -> parameter

parameters
 P_Row(i)
 P_Clm(j)
;

 P_Row(i)=1.0;
 P_Clm(j)=1.0;

** 2021 4 15 alternative price of new process introduced

parameters
 PNT_R(i)
;

 PNT_R(i)=1.0;

* 2021 4 27 price for final demand revised
parameters
 PFD_Csp(i, csp)
 PFD_Cpf(i, cpf)
;
 PFD_Csp(i, csp)=PNT_R(i);
 PFD_Cpf(i, cpf)=PNT_R(i);

 PFD_Csp("89", csp)=PNT_R("89");
 PFD_Csp("90", csp)=PNT_R("90");



* 2020 10 16 share of capital and wage according to CES function

Equations
 K_shr_def(j)
 L_shr_def(j)
;

** 20220816  modify distribution

Equations
 Vad_Wge_df(j)
 Vad_Rtn_df(j)
 Vad_Oth_df(j)
;


* for step 1 and 2
* modify for step-4

* 2021 4 15 modified real price index of NT PNT_R

** 2021 4 15 production function switchablity

Parameters
  IntrVad(j)
  EX_VadSH(vad, j)
;

Positive variables
  Ex_TVad(j)
*  Ex_YVD(vad,j)
;

Variable Ex_Cpf(i,j);
 Ex_Cpf.FX(i,j)=0.0;

  IntrVad(j_15)=1;
  IntrVad(j_50)=0;
  Ex_XAij.FX(i,j)=0.0;

  XAIJ_def(i_15,j)..
    XAIJ(i_15,j) =E= IntrVad(j)*T_vad(j)*VAIO(i_15,j)*PNT_R(i_15)
                    +(1-IntrVad(j))*Ex_XAIJ(i_15,j);

  XAIJ.FX(i_50,j_50)=0.0;

** SaaS productivity improvement 2020 9 26
* modification 20200927, 20201026

Scalars

 PrdUP_ICT  /0.15/
 Inv_Wge_R  /0.08/

 ICTprdGen  whole industry /0.201597893/
;

ICT_PRDupf(j)$(ICT_PRDupf(j) le 0.)=ICTprdGen;

Parameters SaSUP(j), SaSALF(j), WgeR(j);

  WgeR(j)=Inv_Wge_R ;
  WgeR(j)$(ICT_PRDupf(j) le 0.1)=ICT_PRDupf(j)*0.08/0.15;

  SaSALF(j)=WgeR(j)/ICT_PRDupf(j);

  SaSUP(j_SAS)=ICT_PRDupf(j_SaS) /WgeR(j_SaS)**SaSALF(j_SAS) ;
  SaSUP(j_NSAS)=0.0;

* 20220729 RaaS

Parameters RaSUP(j), RaSALF(j), RasBet(j), RasCof(j);
Scalars

 PrdUP_RaS  /3.0/
 RaS_Wge_R  /3.0/

* 20220803 0.2 -> 0.3

 RasEXR     /0.3/
 RasRPY     /2.0/

 RaSprdGen  whole industry /1.434652307/
;

RasAlf(j)=0.0;
RasBet(j)=0.0;
RasCof(j)=1.0;

RasAlf(j_RaS)=RasEXR/RasRPY;
RasBet(j_RAS)=(Ras_Prdupf(j_Ras)-1)**(1-RasAlf(j_RaS))*RasCof(j_RAS);

positive variables
 RTO_SL(j)
 LbrAug(j)
;

* 20201013 positive -> free

Variables
 EmgImp(i)
 DcrExp(i)
;
* up 0.15 -> 0.35
 RTO_SL.UP(j)=0.35;
 RTO_SL.UP(j_NSAS)=0.0;

Equations
 RTO_SL_df(j)
 LbrAug_df(j)
 TrdBlc_df

 XdmdSlk_df
;

** 20210421

variable X_Dmd_Slk(i);

 X_Dmd_Slk.FX(i)=0.0;

variable  OBJ_Xd_Slk;

Scalar ImpUp;

* 2% added for calculation stability

ImpUp=sum(i, -MIO(i,"imp")-MIO(i,"exp"))/sum(j, MIO("Vad_T",j))+0.05;

display ImpUp;

** 2020 10 16 vad share definition based on CES

  Vad_Sh.L(vad, j)=VadShr(vad,j);
  Vad_Sh.FX("Othrs", j)=VadShr("Othrs",j);

 RTO_SL_df(j)..  RTO_SL(j)=E= (XAIJ("SaaS", j)/(Y_Vad("Wage",j)+1e-5));

* 2021 1 6 =E= -> =L=

 LbrAug_df(j)..
   LbrAug(j) =L= SaSUP(j)*(RTO_SL(j)+1e-5)**SaSAlf(j)
         - SaSUP(j)*1e-5**SaSAlf(j) + 1.0;

** 20220729 for RaaS

positive variables
 RTO_RL(j)
 LbrAugRas(j)
;

RTO_RL.UP(j)=1;
RTO_RL.UP(j_Ras)=Ras_Prdupf(j_Ras)-1;

Equations
 RTO_RL_df(j)
 LbrAugRs_df(j)
;

 RTO_RL_df(j_Ras)..   RTO_RL(j_Ras)=E= (XAIJ("RaaS", j_Ras)/(Y_Vad("Wage",j_Ras)+1e-5));

 LbrAugRs_df(j_Ras)..
   LbrAugRas(j_RAS)=E= 
      RasBet(j_RAS)*(RTO_RL(j_Ras)+1e-5)**RaSAlf(j_Ras) 
         - RasBet(j_RAS)*1e-5**RaSAlf(j_Ras) - RTO_RL(j_RAS)+1.0;


 X_ddmd_df(i)..
  X_Ddmd(i)=E=Sum(j, XAIJ(i,j))+sum(csp, (FD_csp(i,csp)))+sum(cpf, FD_cpf(i,cpf))+X_Dmd_Slk(i);

 XdmdSlk_df.. OBJ_Xd_Slk=E=sum(i, X_Dmd_Slk(i)*X_Dmd_Slk(i));

** 2020 12 11 modified

 M_Clm_Bal(j)..
  sum(i, P_ROW(i)*XAij(i,j))+T_Vad(j) =E= X_clm(j)*P_CLM(j);

 M_Row_bal(i).. X_Ddmd(i) + X_ex(i)-X_im(i)  =E= X_Row(i);

** 20220703 expanded
** 20220716 rxpanded

variable YldVR(i);
  YldVR.FX(i)=0.0;
Equation YldVr_df;

 YldVr_df.. sum(i_OPs, YldVR(i_Ops)/OilPrc(i_Ops))=E=0.0;

 R_C_bal(i).. sum(j, ijcnv(i,j)*X_clm(j)) + X_FLX(i) + YldVR(i) =E=X_Row(i);

** 2020 12 11  P_RC_bal(i).. sum(j, ijcnv(i,j)*P_clm(j))=E=P_Row(i);


** 2020 9 26 expanded for SaaS productivity
** 2021 4 15 power sectors 89 and EFC excluded


  Ex_TVad.FX(j)=0;

*  Ex_YVD.FX(vad,j)=0;

  EX_VadSH(vad, j)=MIO(vad, j)/MIO("Vad_T", j);

 VAD_Def(j)..
   T_Vad(j)+ Vad_SLK(j) =E= IntrVad(j)*(
       AY(j)*( (KY(j)+1e-7)**KLBT(j)
     + BY(j)*(
         (LY(j)+1e-7)*(LbrAug(j)+LbrAugRas(j)-1))**KLBT(j))
           **(1.0/KLBT(j)) )
      + (1-IntrVad(j))*Ex_TVad(j);

* 20220816 modified

 Vad_Wge_df(j_15)..
    Y_vad("Wage", j_15)=E=
     IntrVad(j_15)*( MIO("Wage",j_15)*( ( (LY(j_15)+1e-5)/(LBR_i(j_15)+1e-5))*((T_Vad(j_15)+1e-5)/(MIO("Vad_T",j_15)+1e-5)) )**0.5)
   +(1-IntrVad(j_15))*Ex_TVad(j_15)*EX_VadSH("Wage", j_15);

 Vad_Rtn_df(j_15)..
    Y_vad("Rtrn", j_15)=E=
     IntrVad(j_15)*( T_Vad(j_15)* (1.0-VadShr("Othrs", j_15))-Y_vad("Wage", j_15) )
    +(1-IntrVad(j_15))*Ex_TVad(j_15)*EX_VadSH("Rtrn", j_15);

 Vad_Oth_df(j_15).. Y_vad("Othrs", j_15)=E= T_Vad(j_15)-Y_vad("Rtrn", j_15)-Y_vad("Wage", j_15);

 K_shr_def(j_50)..
   Vad_sh("Rtrn",j_50) =E=
       IntrVad(j_50)*(1.0-Vad_Sh("Othrs", j_50))*PKY(j_50)*KY(j_50)
      /(PKY(j_50)*KY(j_50)+PLY(j_50)*LY(j_50)+1e-5);

 L_shr_def(j_50)..
   Vad_sh("Wage",j_50)=E= 1.0 - Vad_sh("Rtrn",j_50)-Vad_sh("Othrs",j_50);

 Vad_Shr_df(vad, j_50)..
    Y_Vad(vad,j_50)=E=
      IntrVad(j_50)*(T_vad(j_50)*Vad_Sh(vad, j_50))

     +(1-IntrVad(j_50))*Ex_TVad(j_50)*EX_VadSH(vad, j_50);

 TL_VAD_def.. TL_VAD=E=sum(j, T_Vad(j));

 TrdBlc_df.. sum(i, X_im(i)-X_ex(i))=L= ImpUp*TL_VAD;

* capital formation section
** 20210416 modified
** 20220805 governmental sector revised
** 20230420 modified

 Prv_Cpf_df(i_nscrp).. FD_Cpf(i_nscrp,"CpF_Prv")=E=
    PNT_R(i_nscrp)
      *sum(j,
           IntrVad(j)*Invst(j)*CPfShrs(i_nScrp, "Cpf_prv")*CpfCof(i_nscrp,j)
          + (1-Intrvad(j))*Ex_Cpf(i_nscrp,j)*CPfShrs(i_nScrp, "Cpf_prv")
      );

 Gov_Cpf_df(i_nscrp)..  FD_Cpf(i_nscrp, "CpF_Gov")=E=
    PNT_R(i_nscrp)
      *sum(j,
        IntrVad(j)*Invst(j)*CPfShrs(i_nScrp, "Cpf_gov")*CpfCof(i_nscrp,j)
      + (1-Intrvad(j))*Ex_Cpf(i_nscrp,j)*CPfShrs(i_nScrp, "Cpf_gov")
     );

 Gov_CSP_df(i_nscrp)..
   FD_Csp(i_nscrp, "Csp_Gov")=E=
         MIO(i_nscrp, "Csp_Gov")* PFD_Csp(i_nscrp, "Csp_Gov")*TL_Vad/TTL_Vad_i;

 Oth_CSP_df(i_nscrp)..
    FD_Csp(i_nscrp, "Csp_Oth")=E=
         MIO(i_nscrp, "Csp_Oth")* PFD_Csp(i_nscrp, "Csp_Oth")*TL_Vad/TTL_Vad_i;

 Imp_df(i_nscrp)..
         X_im(i_nscrp)=E= ImCoef(i_nscrp)*X_Ddmd(i_nscrp)+ EmgImp(i_nscrp);

** 20201013 =E=to =L=

 Exp_df_L(i_nScrp)..  X_ex(i_nScrp)=L= ExCoef(i_nScrp)*X_Row(i_nScrp) + DcrExp(i_nScrp);
 Exp_df_U(i_nScrp)..  X_ex(i_nScrp)=L= X_Row(i_nScrp);

 LBR_UP.. sum(j, LY(j))=E=Lbr_sup;


* 20200924

FD_Cpf.LO(i,"CPF_Oth")$(MIO(i, "Cpf_Oth") lt 0)=   MIO(i, "Cpf_Oth");
FD_Cpf.UP(i,"CPF_Oth")$(MIO(i, "Cpf_Oth") lt 0)= - MIO(i, "Cpf_Oth");
FD_Cpf.LO(i,"CPF_Oth")$(MIO(i, "Cpf_Oth") Ge 0)= - MIO(i, "Cpf_Oth");
FD_Cpf.UP(i,"CPF_Oth")$(MIO(i, "Cpf_Oth") Ge 0)=   MIO(i, "Cpf_Oth");

 X_row.FX(i_50)=0.0;
 X_clm.FX(j_50)=0.0;
 XAIJ.FX(i_50,j)=0.0;

 LbrAug.LO(j)=1.0;
 LbrAug.UP(j)=1.0;

 LbrAug.L(j)=1.0;

LbrAugRas.LO(j)=1.0;
LbrAugRas.UP(j)=1.0;

** 20220624 constraint for scrap sectors

X_im.L(i_SCRP)=-MIO(i_SCRP, "Imp");
X_ex.L(i_SCRP)=MIO(i_SCRP, "Exp");
X_Row.FX(i_SCRP)=0.0;

 FD_Csp.FX(i_SCRP,csp)=MIO(i_SCRP, csp);
 FD_Cpf.FX(i_SCRP,cpf)=MIO(i_SCRP, cpf);

** 20220804 revised

  X_ex.UP(i_dms) = MIO(i_dms, "Q_Clm_T")*0.1;
  X_im.up("111")=0.0;

** expanded 20201020

equation i_LMT_df(i_LMT);

i_LMT_df(i_LMT).. X_Row(i_LMT)=E=MIO(i_LMT, "Q_Clm_T")*(TL_VAD/TTL_Vad_i);

** modified 2020 0927

 Variable OBJ, OBJ_i;
 Equation OBJ_def, OBJ_i_df;

* 2022 0718 

equation  Ful_X_PNL_Df;
variable Ful_X_PNL;

Positive variable CSP_SLK(i);

* fixed 20201019

Scalars
 Wgt_1 /1.0/
 Wgt_2 /1.0/
 Wgt_3 /0.0/
 WGT_4 /1.0/;

   Ful_X_PNL_Df..  Ful_X_PNL=E= sum(i_OPs, x_ex(i_OPs)* x_ex(i_OPs) ) + x_ex("36")*x_ex("36");

 OBJ_def..
   OBJ=E=TL_VAD
            - sum(j, XAIJ("SaaS",j))
            - Wgt_1* sum(i, EmgImp(i)*EmgImp(i)+DcrExp(i)*DcrExp(i))
            - Wgt_2* sum(j,  Vad_SLK(j)* Vad_SLK(j))
            - Wgt_3*Ful_X_PNL
            - WGT_4* sum(i, CSP_SLK(i)*CSP_SLK(i)) ;

 OBJ_i_df.. OBJ_i=E=sum(j,  Vad_SLK(j)* Vad_SLK(j));

CSP_SLK.FX(i)=0.0;

model IO_ini /all/;

option ITERLIM =99999;
option RESLIM = 99999;
OPTION SOLPRINT = ON;
OPTION LIMROW   = 0;
OPTION LIMCOL   = 0;

** initial values
 FD_Csp.FX(i, "Csp_Prv")=MIO(i, "Csp_Prv");
 LY.FX(j)=Lbr_i(j);
 KY.FX(j)=K0(j);
 Invst.FX(j)=Invst_i(j);
 X_ex.FX(i)=MIO(i, "exp");

 Y_Vad.L(vad,j_15)=MIO(vad,j_15);
 Y_Vad.FX(vad,j_50)=0.0;

 T_vad.L(j)=sum(vad, MIO(vad,j));
 T_vad.L(j_50)=0.0;

 XAIJ.FX(i,j)=sum(vad, MIO(vad,j))*VAIO(i,j);
 XAIJ.FX(i,j_50)=0.0;
 XAIJ.FX(i_50,j)=0.0;

 X_Ddmd.L(i)= Sum(j, XAIJ.L(i,j))+sum(csp, (FD_csp.L(i,csp)))+sum(cpf, FD_cpf.L(i,cpf));

display PKY,PLY, KY.L;


display X_Ddmd.L, T_Vad.L;

** check XAIJ ini
Put //;

Put "","XAIJ(i,j) initial"/;
Put "",""; loop(j, put j.TL);Put /;
Loop(i,
  Put "",i.TL;
  Loop(j, Put XAIJ.L(i, j):15:5 );
     Put /;
);
Put //;

  solve IO_ini minimizing OBJ_i using NLP;

parameter NscrP(j);

NscrP(j)=XAIJ.L("SCRP_n",j);

display NscrP;

NscrP(j)=NscrP(j)-MIO("SCRP_n",j);

display NscrP;

** 20220624

display Vad_Slk.L;


 Vad_SLK.FX(j)=Vad_SLK.L(j);

 solve IO_ini minimizing OBJ_i using NLP;
 solve IO_ini maxmizing OBJ using NLP;

Parameter MIO_R(i_TL, j_TL);
Scalar GDP;

Put "Step-1 initial solution"/;

$include IOMDL_OUT_O.gms


** 20220624

display AY, BY, k0, Lbr_i, PKY, PLY;

* Step-2 future BAU -- tentative

 XAIJ.LO(i,j)=-INF;
 XAIJ.UP(i,j)= INF;
 XAIJ.L(i,j)=sum(vad, MIO(vad,j))*VAIO(i,j);
 XAIJ.FX(i,j_50)=0.0;
 XAIJ.FX(i_50,j)=0.0;

** trade balance

ImpUP=0.0;

Scalar
 LBR_Grw
 LBR_Grw_30  20-64 /0.89/
 LBR_Grw_50  20-64 /0.684/
 LBR_Grw_50b 20-69 /0.780/
 Pop_Grw_50        /0.84167/
 Csp_Grw_0 /0.94/;

**

* strong assumption

 LBR_Grw=LBR_Grw_50b;
 Csp_Grw_0=Pop_Grw_50**0.5;

Parameter CSP_Grw(i), Csp_Ftr(i);
 CSP_Grw(i)=Csp_Grw_0;

* 78: automobile  97: residential

 CSP_Grw("78")=0.7092**0.5;
 CSP_Grw("89")=1.003;
 CSP_Grw("97")=0.968;

* modified by new product prices 2021 4 15

 Csp_Ftr(i)=MIO(i, "Csp_Prv")*Csp_Grw(i)*PNT_R(i);

* 20210421 modified for trade expansion limit

 LY.LO(j)=Lbr_i(j)*0.5;
 KY.LO(j)=K0(j)*0.1;
* Invst.LO(j)=Invst_i(j)*0.1;
* Invst.LO(j_infr)=Invst_i(j_infr)*0.333;
* Invst.LO(j_infr)=Invst_i(j_infr)*0.333;

Invst.LO(j)=k0(j)*Dlt_i(j)*0.6;
Invst.LO(j_infr)=k0(j_infr)*Dlt_i(j_infr)*0.666;

 X_ex.LO(i)=MIO(i, "exp")*0.33333;

 LY.UP(j)=Lbr_i(j)*10.0;
 KY.UP(j)=K0(j)*10.0;
 Invst.UP(j)=Invst_i(j)*10.0;
 Invst.UP(j_infr)=Invst_i(j_infr)*1.2;

 X_ex.UP(i)=MIO(i, "exp")*3.0;

 LY.L(j)=Lbr_i(j)*LBR_Grw;
 KY.L(j)=K0(j);
 Invst.L(j)=Invst_i(j);
 X_ex.L(i)=MIO(i, "exp");

* 20201217
  X_ex.UP(i_dms) = MIO(i_dms, "Q_Clm_T")*0.1;

* 20220804
  X_im.UP(i_dms) = - MIO(i_dms, "imp");
  X_im.UP(i_dms)$(MIO(i_dms, "imp") lt 0.0)= - MIO(i_dms, "imp")*3.0;

Equations
 Cstk_Gnl_df(j)
 Cstk_bld_df(j);

** 20201128 modified
** 20220713 modified for 2050

Scalar
   Cp_Wgi /0.1/
   YrCpi /2/
   YrCsv /20/;

Cstk_bld_df(j_Bld)..
 KY(j_Bld)=E=K0(j_Bld)*(1.0-Dlt_i(j_Bld))**Yftr
     + ( Invst_i(j_Bld)*Cp_Wgi+Invst(j_Bld)*(1-Cp_Wgi) )
         *YrCsv*(1.0-Dlt_i(j_Bld))**(Yftr-YrCsv)
     + ( Invst_i(j_Bld)*Cp_Wgi+Invst(j_Bld)*(1-Cp_Wgi) )*(Yftr-YrCSV)
;

Cstk_Gnl_df(j_Nbld)..

 KY(j_Nbld)=E=K0(j_Nbld)*(1.0-Dlt_i(j_Nbld))**Yftr

  + (1.0-(1.0-Dlt_i(j_Nbld))**(Yftr+1-YrCpi))/Dlt_i(j_Nbld)*Invst(j_NBld)
  + ((1.0-Dlt_i(j_Nbld))**(Yftr-1)+(1.0-Dlt_i(j_Nbld))**(Yftr-2))*Invst_i(j_Nbld)
;

*          *(Invst_i(j_Nbld)*Cp_Wgi +Invst(j_NBld)*(1-Cp_Wgi));

Lbr_sup=Lbr_sup*LBR_Grw;

* 20220625
 FD_Csp.LO(i_nScrp, "Csp_Prv")$(MIO(i_nScrp, "Csp_Prv") ge 0.0)
    =MIO(i_nScrp, "Csp_Prv")*0.5*PFD_Csp(i_nScrp, "Csp_Prv");

 FD_Csp.UP(i_nScrp, "Csp_Prv")$(MIO(i_nScrp, "Csp_Prv") ge 0.0)
    =MIO(i_nScrp, "Csp_Prv")*2.0*PFD_Csp(i_nScrp, "Csp_Prv");

 FD_Csp.LO(i_nScrp, "Csp_Prv")$(MIO(i_nScrp, "Csp_Prv") LE 0)
    =  MIO(i_nScrp, "Csp_Prv")*PFD_Csp(i_nScrp, "Csp_Prv");

 FD_Csp.UP(i_nScrp, "Csp_Prv")$(MIO(i_nScrp, "Csp_Prv") LE 0)=- MIO(i_nScrp, "Csp_Prv")*PFD_Csp(i_nScrp, "Csp_Prv");

 FD_Csp.L(i_nScrp, "Csp_Prv")=Csp_Ftr(i_nScrp);

 FD_Cpf.LO(i_scrp, "CPF_OTH")$(MIO(i_scrp, "CPF_OTH") ge 0.0)
    =- MIO(i_scrp, "CPF_OTH");

 FD_Cpf.UP(i_scrp, "CPF_OTH")$(MIO(i_scrp, "CPF_OTH") ge 0.0)
    =MIO(i_scrp, "CPF_OTH")*2.0;

 FD_Cpf.LO(i_scrp, "CPF_OTH")$(MIO(i_scrp, "CPF_OTH") LE 0)
    =  MIO(i_scrp, "CPF_OTH")*2.0;

 FD_Cpf.UP(i_scrp, "CPF_OTH")$(MIO(i_scrp, "CPF_OTH") LE 0)
    =- MIO(i_scrp, "CPF_OTH");

** 20220815 modify the upperbound of education expenditure in private sector
*  due to the high income elasticity

 FD_Csp.UP("112", "Csp_Prv") =MIO("112", "Csp_Prv")*5.0;

* 20220626

 FD_Cpf.LO(i, "CPF_OTH")$(MIO(i, "CPF_OTH") LE 0) =  - MIO(i, "Q_CLM_T")*0.1;
 FD_Cpf.UP(i, "CPF_OTH")$(MIO(i, "CPF_OTH") LE 0) =    MIO(i, "Q_CLM_T")*0.1;

 FD_Cpf.LO(i, "CPF_OTH")$(MIO(i, "CPF_OTH") GT 0) =  - MIO(i, "Q_CLM_T")*0.1;
 FD_Cpf.UP(i, "CPF_OTH")$(MIO(i, "CPF_OTH") GT 0) =    MIO(i, "Q_CLM_T")*0.1;

 x_im.UP("87")=MIO("87", "Q_CLM_T")*0.1;

* 2021 4 27 modified

Equation Csmp_def(i);

** 20220805

Csmp_def(i)$(MIO(i, "Csp_Prv") gt 0)..
  FD_Csp(i, "Csp_Prv") =E= Csp_Ftr(i)*(TL_VAD/TTL_VAD_i)**Y_els(i)
     * PFD_Csp(i, "Csp_Prv")+CSP_SLK(i);

** production uppse limit
* 2021 4 15 modified

Scalar i_UP_R /1.05/;

X_Row.UP(i_UP)=MIO(i_UP, "Q_Clm_T")*i_UP_R *PNT_R(i_up);

** stock upper limit 20201127

parameter K_UP_R(j);
 K_UP_R(j)=inf;
 K_UP_R("87")=1.0;
*K_UP_R("97")=0.988;

 K_UP_R("97")=1.02;

* 20220616 modified KY.FX(j_Bld)=k0(j_Bld)*K_UP_R(j_Bld);

* KY.UP(j_Bld)=k0(j_Bld)*K_UP_R(j_Bld)*1.5;
* KY.LO(j_Bld)=k0(j_Bld)*K_UP_R(j_Bld)*0.5;

* 20220707 export-import balance introduced

Parameter ImExR_ini(i), ImExR_ini(i);

ImExR_ini(i)=MIO(i, "EXP")-MIO(i, "Imp");

 ImExR_ini(i)$(ImExR_ini(i) gt 0)=MIO(i, "EXP")/ImExR_ini(i);

display ImExR_ini, ImExR_ini;

model IO_ftr /all/;

solve IO_ftr maximizing OBJ using NLP;

Variables  ExpShr_TL, OBJ_XTr;
Equations  ExpShr_TL_df, OBJ_Xtr_df;

Scalar Wgt_Xtr /1.0/;

ExpShr_TL_df..
  ExpShr_TL=E=sum(i, (X_ex(i)/(X_ex(i)+X_im(i)+1.e-3)-ImExR_ini(i))*(X_ex(i)/(X_ex(i)+X_im(i)+1.e-3)-ImExR_ini(i)));

OBJ_Xtr_df.. OBJ_XTr =E= OBJ - Wgt_Xtr*ExpShr_TL;


 FD_Cpf.LO(i, "CPF_OTH")$(MIO(i, "CPF_OTH") LE 0) =  - MIO(i, "Q_CLM_T")*0.005;
 FD_Cpf.UP(i, "CPF_OTH")$(MIO(i, "CPF_OTH") LE 0) =    MIO(i, "Q_CLM_T")*0.01;

 FD_Cpf.LO(i, "CPF_OTH")$(MIO(i, "CPF_OTH") GT 0) =  - MIO(i, "Q_CLM_T")*0.005;
 FD_Cpf.UP(i, "CPF_OTH")$(MIO(i, "CPF_OTH") GT 0) =    MIO(i, "Q_CLM_T")*0.01;

Model IO_ftr_Xt /all/;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

* 20220812 modified

Parameter VAD_RTO_O(j), VAD_RTO(j);

VAD_RTO(j)=1.0;
VAD_RTO_O(j)=1.0-sum(i, AIO(i,j));


 X_ex.UP("35_a")=X_ex.L("35_a")*10.0;
 FD_csp.LO("35_a", "Csp_prv")=0.0;


** 2020 12 12 convergence of relative price

VAIO_0(i,j)=VAIO_ORG(i,j);
PCLM_wrk0(j)=sum(i, vaio_ORG(i,j)*PNT_R(i))+1;

PCLM_wrk1(j)=sum(i, vaio(i,j)*PNT_R(i))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

P_clmW(j)=P_CLM(j)

display PCLM_wrk0, PCLM_wrk1, P_CLM, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

*======================

EmgImp.LO(i)=-inf;
EmgImp.UP(i)=+inf;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

Wgt_3=1.0;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-2: future tentative BAU"/;
$include IOMDL_OUT_O.gms

** New step-3 future consumption with new vehcles and ZEH houses 2020 10 12
**  electrify industry sectors 2020 12 05
* 35_:oil 89:elec 90:gas 97:residential bldg
* 79: other vehicles  99: road transportaion 2020 10 23
* 20201216 value added ratio
* 20220716 Yield change between gasolin and naphtha

set i_HhFl(i) /35_c, 35_h, 90/;

display SlsSh_V50, Csp_Ftr,Pi_vcl;

* LY.LO(j)$(LY.L(j) eq LY.LO(j))=LY.L(j)*0.333;
* Invst.LO(j)$(Invst.LO(j) eq Invst.L(j))=Invst.L(j)*0.5;

csp_slk.UP(i)=0.0;

Scalar YldOP_UP /1.0/;

YldVR.UP("35_a")=   YldOP_UP*MIO("35_a","Q_Clm_T");
YldVR.LO("35_a")= - YldOP_UP*MIO("35_a","Q_Clm_T");

YldVR.UP("35_g")=   YldOP_UP*MIO("35_g","Q_Clm_T");
YldVR.LO("35_g")= - YldOP_UP*MIO("35_g","Q_Clm_T");

* Parameter VAD_RTO_O(j), VAD_RTO(j);

VAD_RTO(j)=1.0;
VAD_RTO_O(j)=1.0-sum(i, AIO(i,j));

* 2020 10 13 added
* 20220807 modifided

Csp_Ftr("89")=
 MIO("89", "Csp_Prv") * PFD_Csp("89", "Csp_Prv") *
  ( (1.0-NwSt_Rto)*sum(Rsb, ElcRtio(Rsb)*Sh_Srsb(Rsb))
   + NwSt_Rto*sum(Rsb, ElcRtio(Rsb)*Sh_Nrsb(Rsb)));

Csp_Ftr(i_HhFl)=
 MIO(i_HhFl, "Csp_Prv") * PFD_Csp(i_HhFl, "Csp_Prv") *
  ( (1.0-NwSt_Rto)*sum(Rsb, GasRtio(Rsb)*Sh_Srsb(Rsb))
   + NwSt_Rto*sum(Rsb, GasRtio(Rsb)*Sh_Nrsb(Rsb)));


Csp_Ftr("97")=
 MIO("97", "Csp_Prv") *  PNT_R("97")*
  ( (1.0-NwSt_Rto)*sum(Rsb, Pi_rsb(Rsb)*Sh_Srsb(Rsb))
   + NwSt_Rto*sum(Rsb, Pi_rsb(Rsb)*Sh_Nrsb(Rsb)));

* New vehicles  78:passenger car

parameter MslsSh_V50(VCLE);
Scalar TlWrk;

** CEV introduced
 SlsSh_V50("CEV")=SlsSh_V50("EV")*0.2;
 SlsSh_V50("EV")=SlsSh_V50("EV")*0.8;
 SlsSh_V50("ICE")=
      1.0- SlsSh_V50("HV")- SlsSh_V50("PHV")-SlsSh_V50("CEV")-SlsSh_V50("EV");

 StkSh_V50("CEV")=StkSh_V50("EV")*0.3;
 StkSh_V50("EV")=StkSh_V50("EV")*0.7;
 StkSh_V50("ICE")=
      1.0-StkSh_V50("HV")-StkSh_V50("PHV")-StkSh_V50("CEV")-StkSh_V50("EV");


MslsSh_V50(VCLE)=SlsSh_V50(VCLE)*Pi_vcl(VCLE);
TlWrk=sum(VCLE, MslsSh_V50(VCLE));
MslsSh_V50(VCLE)=MslsSh_V50(VCLE)/TlWrk;

parameter VAaio_wrk(i_tl);

VAaio_wrk(i_tl)= AIO(i_TL, "78");

 AIO(i_TL, "78")=sum(VCLE, P_vcl(VCLE)*AIO_VCL(i_TL, VCLE)*MSlsSh_V50(VCLE));

 VAIO(i,"78") =AIO(i,"78")/sum(VCLE, AIO_VCL("VAD_T",VCLE)*MSlsSh_V50(VCLE));

 Csp_Ftr("78")=Csp_Ftr("78")
     *sum(VCLE, SlsSh_V50(VCLE)*Pi_vcl(VCLE));
;

display SlsSh_V50, Csp_Ftr,Pi_vcl;

* fuel modification

Scalar Fuel_T_50, NwSt_R_V, RdcFuel, Elec_T_50,IncElec;

Elec_T_50=Csp_Ftr("89");

NwSt_R_V=VclSls_50/(VclStk_50*(1.0+Csp_Grw("78"))/2.0) ;

Fuel_T_50=Csp_Ftr("35_a");

RdcFuel = Csp_Ftr("78")
       * sum(VCLE, SlsSh_v50(VCLE)*Pi_vcl(VCLE)*Oil_Rdc(VCLE) )
     +    Csp_Ftr("78")/NwSt_R_V
       * sum(VCLE, StkSh_v50(VCLE)*Pi_vcl(VCLE)*Oil_Rdc(VCLE) )
;

 Csp_Ftr("35_a")=Fuel_T_50-RdcFuel;

* 20220713

 X_ex.UP("35_a")=X_ex.L("35_a")*10.0;
 FD_csp.LO("35_a", "Csp_prv")=0.0;

display Fuel_T_50, RdcFuel;

IncElec = Csp_Ftr("78")
  * ( sum(VCLE, StkSh_v50(VCLE)*Pi_vcl(VCLE)*Elc_Inc(VCLE))/NwSt_R_V
     + sum(VCLE, SlsSh_v50(VCLE)*Pi_vcl(VCLE)*Elc_Inc(VCLE) ));
;

Csp_Ftr("89")=Elec_T_50 + IncElec;

display Elec_T_50, IncElec;

** modify freight transportation

AIO(i, Fr_tr)=AIO_FRV(i, Fr_tr);
VAIO(i, Fr_tr)=VAIO_FRV(i, Fr_tr);


** Power industry by LCS-2030 20201215
* simplified formulation in 89:elec. power
** 2021 4 15 Power industry sector changed

AIO(i, "89")=ShrLCS*LCS_EL_AIO(i)+(1.0-ShrLCS)*AIO(i, "89");
VAIO(i, "89")=AIO(i, "89")/(1.0-sum(ii,AIO(ii, "89")));

VAD_RTO("89")=(1.0-sum(i, AIO(i,"89")))/VAD_RTO_O("89");
VAD_RTO_O("89")=1.0-sum(i, AIO(i,"89"));

Dlt_i("89")=ShrLCS*0.025+(1.0-ShrLCS)*Dlt_i("89");

PNT_R("89")= ShrLCS* NwElc_PR + (1.0-ShrLCS)*1.0;

 PFD_Csp("89", csp)=PNT_R("89");
 PFD_Cpf("89", cpf)=PNT_R("89");

display VAD_RTO;

K_shr("89")=1.0-LCS_EL_AIO("Wage")/LCS_EL_AIO("Vad_T");

BY("89")$(k0("89") gt 0)=(1.0-K_shr("89"))/K_shr("89")*(Lbr_i("89")/K0("89"))**(-KLBT("89"));

ClWrk("89")$(k0("89") gt 0)=(K0("89")**KLBT("89") + BY("89")*Lbr_i("89")**KLBT("89"))**(1.0/KLBT("89"));
AY("89")$(k0("89") gt 0)=MIO("Vad_T","89")/ClWrk("89");

invst.L("89")=8.102;

** 2020 12 12 convergence of relative price


VAIO_0(i,j)=VAIO_ORG(i,j);
PCLM_wrk0(j)=sum(i, vaio_ORG(i,j)*PNT_R(i))+1;

PCLM_wrk1(j)=sum(i, vaio(i,j)*PNT_R(i))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

P_clmW(j)=P_CLM(j)

display PCLM_wrk0, PCLM_wrk1, P_CLM, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

*======================

EmgImp.LO(i)=-inf;
EmgImp.UP(i)=+inf;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

Wgt_3=5.0;

* LY.LO(j)$(LY.L(j) eq LY.LO(j))=LY.L(j)*0.333;
* Invst.LO(j)$(Invst.LO(j) eq Invst.L(j))=Invst.L(j)*0.5;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-3 : Consumption changes by ZEH and New Vehicles and elec for ind. sectors"/;

$include IOMDL_OUT_S135.gms


**----- Society 5.0

** step-4 new ICT services for 2050
* consumption of ICT services 300% of 2030

 Scalar Infs_50 /5.0/;

 IntrVad("InfS")=1;
 Y_vad.LO(vad, "Infs")=0.0;
 Y_vad.UP(vad, "Infs")=INF;

 X_row.UP("InfS")=INF;
 X_clm.UP("InfS")=INF;
 XAIJ.UP(i_15, "InfS")=INF;
 XAIJ.LO(i_15, "InfS")=-INF;

 XAIJ.UP("InfS",j)=INF;
 XAIJ.LO("InfS",j)=-INF;

 XAIJ.LO(i_50, "InfS")=0.0;

 LY.UP("InfS")=Lbr_i("108")*2.0*Infs_50;
 KY.UP("InfS")=K0("108")*10.0;
 Invst.UP("InfS")=Invst_i("108")*10.0;

 X_ex.FX(i_50)=0.0;
 X_im.FX(i_50)=0.0;
 XAIJ.FX(i_50, j_50)=0.0;

 FD_Csp.UP("InfS", "Csp_Prv")=INF;

* connected car service 0.169 trillion added

 FD_Csp.LO("InfS", "Csp_Prv")=(1.478+0.169)*Infs_50;

 LY.L("InfS")=LY.L("108")*0.1;
 KY.L("InfS")=KY.L("108")*0.1;
 Invst.L("InfS")=Invst.L("108")*0.1;
 T_Vad.L("InfS")=T_Vad.L("108")*0.1;

 XAIJ.FX("InfS",j )=0.0;

EmgImp.LO(i)=-inf;
EmgImp.UP(i)=+inf;

* LY.LO(j)$(LY.L(j) eq LY.LO(j))=LY.L(j)*0.333;
* Invst.LO(j)$(Invst.LO(j) eq Invst.L(j))=Invst.L(j)*0.5;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-4a: Information services for consumption with EV "/;

$include IOMDL_OUT_S135.gms


** Step-4b SaaS for productivity augumentation for 2050

Scalar SaaS_50 /1.2/;

 IntrVad("SaaS")=1;
 Y_vad.LO(vad, "SaaS")=0.0;
 Y_vad.UP(vad, "SaaS")=INF;

 LbrAug.UP(j)=SasUP(j)**(1/(1.0-SaSAlf(j))) +1.0;
 LbrAug.UP(j)$(SasUP(j) le 0.25)=1.25*SaaS_50;

 LbrAug.LO(j)=1.0;
 LbrAug.L(j)=1.0;

** 20210111 for -b

LbrAug.UP(j)=1.20*SaaS_50;

 X_row.UP("SaaS")=INF;
 X_clm.UP("SaaS")=INF;
 XAIJ.UP(i_15, "SaaS")=INF;
 XAIJ.LO(i, "SaaS")=0.0;

 XAIJ.UP("SaaS",j_15)=INF;
 XAIJ.LO("SaaS",j_SAS)=0.001*MIO("108",j_SAS);

 XAIJ.UP("SaaS",j)=INF;
* XAIJ.LO("SaaS",j)=-INF;

 LY.UP("SaaS")=Lbr_i("108")*2.0*SaaS_50;
 KY.UP("SaaS")=K0("108")*10.0;
 Invst.UP("SaaS")=Invst_i("108")*10.0;

 LY.L("SaaS")=LY.L("108")*0.1;
 KY.L("SaaS")=KY.L("108")*0.1;
 Invst.L("SaaS")=Invst.L("108")*0.1;
 T_Vad.L("SaaS")=T_Vad.L("108")*0.1;

 XAIJ.L(i, "SaaS")=XAIJ.L(i, "108")*0.1;

 XAIJ.FX(i_50, j_50)=0.0;

EmgImp.LO(i)=-inf;
EmgImp.UP(i)=+inf;

* LY.LO(j)$(LY.L(j) eq LY.LO(j))=LY.L(j)*0.333;
* Invst.LO(j)$(Invst.LO(j) eq Invst.L(j))=Invst.L(j)*0.5;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-4b : SaaS for productivity with EV : Power sector investment by factor"/;

$include IOMDL_OUT_S135.gms

** Step-4c ; MaaS and consumption pattern change for 2050

Scalar MaaS_50 /3.0/;

 IntrVad("MaaS")=1;
 Y_vad.LO(vad, "MaaS")=0.0;
 Y_vad.UP(vad, "MaaS")=INF;

display AY, BY, k0, Lbr_i, PKY, PLY;

** 2030 0.7 -> 2050  0.3

 Scalar PrvCarRD /0.3/;


 X_row.UP("MaaS")=INF;
 X_clm.UP("MaaS")=INF;
 XAIJ.UP(i_15, "MaaS")=INF;
 XAIJ.LO(i, "MaaS")=0.0;

 XAIJ.UP("MaaS",j_15)=INF;
 XAIJ.LO("MaaS",j_15)=0;

* XAIJ.FX(i_50, "MaaS")=0.0;


 LY.UP("MaaS")=Lbr_i("108")*2.0;
 KY.UP("MaaS")=K0("108")*10.0;
 Invst.UP("MaaS")=Invst_i("108")*10.0;

 FD_Csp.UP("MaaS", "Csp_Prv")=INF;
 FD_Csp.LO("MaaS", "Csp_Prv")=3.435*MaaS_50;

* software service for MaaS

 FD_Csp.LO("InfS", "Csp_Prv")=(1.478+0.169)*Infs_50+ (0.736-0.169)*MaaS_50;

 LY.L("MaaS")=LY.L("108")*0.1;
 KY.L("MaaS")=KY.L("108")*0.1;
 Invst.L("MaaS")=Invst.L("108")*0.1;
 T_Vad.L("MaaS")=T_Vad.L("108")*0.1;

display AY, BY,KLBT;

* XAIJ.FX("MaaS",j )=0.0;
* XAIJ.LO(i, "MaaS")=0.0;

 Csp_Ftr("MaaS")=3.435*MaaS_50;

* decrease of private car related expenditure
* 35_a- fuel   78- automobile  89-electricity 95- insurance  99 - taxi

 Csp_Ftr("35_a")=Csp_Ftr("35_a")*PrvCarRD;
 Csp_Ftr("78")=Csp_Ftr("78")*PrvCarRD;
 Csp_Ftr("95")=Csp_Ftr("95")*((1.0-0.35)+0.35*PrvCarRD);

 Csp_Ftr("99")=Csp_Ftr("99")- 0.153*MaaS_50 + 0.6008*MaaS_50;

* LY.LO(j)$(LY.L(j) eq LY.LO(j))=LY.L(j)*0.333;
*Invst.LO(j)$(Invst.LO(j) eq Invst.L(j))=Invst.L(j)*0.5;

solve IO_ftr_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-4c: EV, ZEH, CEV and MaaS for mobility : Power sector investment by factor"/;

$include IOMDL_OUT_S135.gms

** Step-4d RaaS for productivity augumentation for 2050
*  export of RaaS included

CPfShrs("RaaS", "Cpf_prv")=1.0;

RasCof(j)=1.0;
RasBet(j_RAS)=(Ras_Prdupf(j_Ras)-1)**(1-RasAlf(j_RaS))*RasCof(j_RAS);

 IntrVad("RaaS")=1;
 Y_vad.LO(vad, "RaaS")=0;
 Y_vad.UP(vad, "RaaS")=INF;

 LbrAugRas.UP(j_Ras)=Ras_Prdupf(j_Ras);

 LbrAugRas.LO(j)=1.0;
 LbrAugRas.L(j)=1.0;

display rasbet, rasalf, AY, BY, KLBT, k0, Lbr_i, PKY, PLY;

** 20210111 for -b

 X_row.UP("RaaS")=INF;
 X_clm.UP("RaaS")=INF;
 XAIJ.UP(i_15, "RaaS")=INF;
 XAIJ.LO(i, "RaaS")=-INF;

 XAIJ.UP("RaaS",j_15)=INF;
 XAIJ.LO("RaaS",j_15)=0.0;

 XAIJ.UP("RaaS",j_NRAS)=0.0;

 LY.UP("RaaS")=Lbr_i("67")*20.0;
 KY.UP("RaaS")=K0("67")*20.0;
 Invst.UP("RaaS")=Invst_i("67")*30.0;

 LY.L("RaaS")=LY.L("67")*0.1;
 KY.L("RaaS")=KY.L("67")*0.1;
 Invst.L("RaaS")=Invst.L("67")*0.1;
 T_Vad.L("RaaS")=T_Vad.L("67")*0.1;

 XAIJ.L(i, "RaaS")=XAIJ.L(i, "67")*0.1;

 XAIJ.FX(i_50, j_50)=0.0;

EmgImp.LO(i)=-inf;
EmgImp.UP(i)=+inf;

* LY.LO(j)$(LY.L(j) eq LY.LO(j))=LY.L(j)*0.333;
* Invst.LO(j)$(Invst.LO(j) eq Invst.L(j))=Invst.L(j)*0.5;

X_ex.UP("RaaS")=INF;

Equation Ex_Ras_df;

 Ex_Ras_df..
   X_ex("RaaS") =E=X_Clm("RaaS")*MIO("67", "Exp")/MIO("67", "Q_CLM_T");

Model IO_ftr_XtR /All/;

solve IO_ftr_XtR maximizing OBJ_Xtr using NLP;

Put //;Put "Step-4d : RaaS for productivity with EV : Power sector investment by factor"/;

$include IOMDL_OUT_S135.gms


*-- Step 5 LCS power scenario for 2050 
*======================
*** 20210415 expanded
* LCS scenario for Power generation sectors 89 and EFC
* 2021 4 21 no longer coal and oil fired plants

ImpUP=0.01;

YldVR.UP("35_b")=   YldOP_UP*MIO("35_b","Q_Clm_T");
YldVR.LO("35_b")= - YldOP_UP*MIO("35_b","Q_Clm_T");

YldVR.UP("35_c")=   YldOP_UP*MIO("35_c","Q_Clm_T");
YldVR.LO("35_c")= - YldOP_UP*MIO("35_c","Q_Clm_T");

YldVR.UP("35_d")=   YldOP_UP*MIO("35_d","Q_Clm_T");
YldVR.LO("35_d")= - YldOP_UP*MIO("35_d","Q_Clm_T");

 Scalar CstDN_50 /0.5/;

** 20220802

 Parameter Wge_Ras_RTE(j_EL);

 Wge_Ras_RTE(j_EL)=XAIJ.L("RaaS", j_EL)/T_vad.L(j_EL);

 display Wge_Ras_RTE;

 set i_NFOS(i) /1*5, 7a,7b, 8*34, 35_a, 35_b, 35_c,35_d,35_e,35_f,35_g,35_h,35_i, 36*47, SCRP_s, 48*53, SCRP_n, 54*88, EFC, 89*128, SaaS, MaaS, InfS, H2/;

Parameter LCSPwrGen(i_TL);
 LCSPwrGen(i_TL)=1;
 LCSPwrGen(i_OPs)=0;
 LCSPwrGen("36")=0;


  IntrVad(j_El)=0;

  T_Vad.L(j_El)=MIO("Vad_T", j_EL);
  Y_vad.L(vad, j_El)=MIO(vad, j_EL);

*  Vad_sh.L("Rtrn",j_El)=MIO("Rtrn", j_EL)/MIO("Vad_T", j_EL);
*  Vad_sh.L("Othrs",j_El)=MIO("Othrs", j_EL)/MIO("Vad_T", j_EL);
*  Vad_sh.L("Wage",j_El)=MIO("Wage", j_EL)/MIO("Vad_T", j_EL);

  Ex_TVad.UP(j_el)=INF;

  Ex_XAIJ.UP(i,j_EL)=INF;
  Ex_XAIJ.LO(i,j_EL)=-INF;

  Ex_Cpf.UP(i,j_EL)=INF;
  Ex_Cpf.LO(i,j_EL)=-INF;

  Ex_Tvad.L(j_EL)=T_vad.L(j_EL);

set ASSTS /PWRG, TRDS, BSNS, ASTTL/
    ASSTr(ASSTS) /PWRG, TRDS, BSNS/
    Trms  /AST2015, INV2015, INV_LCS, RsdVR/
    PwrG /HYDR, ColF, GasF, OilF, Nucr,Wind, Solar, GeoT, Biom, Btry/
    PwTrms /Cap2015, Out2015, InvLCS, RsdRt, CpUtlR, BldCst, LglLfy, PrcDwn, As_2015/

    PwrS /NCR, Frd, HYD, Sol, WND, RNW, TRD, BUS/
    PwrSg(PwrS) /NCR, Frd, HYD, Sol, WND, RNW/

    PwrGen(PwrG) /HYDR, GasF, Wind, Solar, GeoT, Btry/
;

Parameters CstDN_PWG(pwrg);


 CstDN_PWG(pwrg)=1.0;

 CstDN_PWG("Solar")=0.96**(2050-2015);
 CstDN_PWG("Wind")=0.98**( (2050-2020)/5 );
 CstDN_PWG("HYDR")=0.8616**( (2050-2020)/5 );


Table CNV_GS(PwrS, PwrG)
      HYDR ColF GasF OilF Nucr Wind Solar GeoT Biom Btry
NCR                        1
Frd          1   1    1
HYD     1
Sol                                  1
WND                              1
RNW                                        1    1
TRD
BUS
;

** 20220704 matrix for fuel source and PwrG

set i_FOS(i) /6a, 6b, 6c/;

Table FOS_PwrG(i_FOS, PwrG)
      HYDR ColF GasF OilF Nucr Wind Solar GeoT Biom Btry
6a          1
6b                    1
6c                1
;

Parameter CstDwn(i, PwrS);

 CstDwn(i, PwrS)=1.0;
 CstDwn("72", "Sol")=0.51*CstDN_50;
 CstDwn("75", "Sol")=0.51*CstDN_50;
 CstDwn("66", "WND")=0.88*CstDN_50;
 CstDwn("71", "WND")=0.88*CstDN_50;

 Parameter ElcInvT(PWRS);

* for XAIJ(Fossifuel, Power) only in JPY per kWh
Scalar FulCst;

 FulCst=10.98*0.42/0.56;

Parameter PG_LCS_S(PwrG);
 PG_LCS_S(PwrG)=0;
 PG_LCS_S(PwrGen)=1;

** 20230606 according to DynG

Parameter PG_Adj(PwrG);
 PG_Adj(PwrG)=0.0;
 PG_Adj(PwrGen)=1.0;


Table AstMtx(ASSTS, Trms)
$call=xls2gms r=b1868:F1872 i=IO2015_135_2050_Dat.xlsx o=ASSTX.inc
$include ASSTX.inc
;

Table PwgAst(PwrG, PwTrms)
$call=xls2gms r=B1876:K1886 i=IO2015_135_2050_Dat.xlsx o=ASSTG.inc
$include ASSTG.inc
;

Parameter PwgX_Adj(PwrG);
Scalar BAU_Inv2015, BAU_Inv2050, PwgX_Els;

BAU_Inv2015 =sum(PwrG, PwgAst(PwrG, "InvLCS") );
BAU_Inv2050 =sum(PwrG, PwgAst(PwrG, "InvLCS")*CstDN_PWG(PwrG) );

 PwgX_Els=0.25;

 PwgX_Adj(PwrG)=1.0;
 PwgX_Adj(PwrG)=(BAU_Inv2015/BAU_Inv2050)**PwgX_Els;


Scalar CapCstRt /0.1263161/;

Positive variable
  PwrExp
  InvPwrS(ASSTS)
  InvPwrG(PwrG)
  AstPwrS(ASSTS)
  CapPwr50(PwrG)
  OutPwr50(PwrG)
 ;

Equations
 InPwS_df(ASSTS)
 InPwG_df(PwrG)
 AsPwS_df(ASSTr)
 AsPwTL_df

  CapPwr50_df(PwrG)
  OutPwr50_df(PwrG)

;

PwrExp.LO=0.2;
PwrExp.UP=10.0;

PwrExp.L=1.0;

InPwS_df(ASSTr).. InvPwrS(ASSTr)=E=PwrExp*AstMtx(ASSTr, "Inv_LCS");

AsPwS_df(ASSTr)..
  AstPwrS(ASSTr)=E=
    (AstMtx(ASSTr,"AST2015")+AstMtx(ASSTr,"INV2015"))*AstMtx(ASSTr,"RsdVR")**Yftr
  + InvPwrS(ASSTr)*(1.0-AstMtx(ASSTr,"RsdVR")**Yftr)/(1.0-AstMtx(ASSTr,"RsdVR"));

AsPwTL_df.. AstPwrS("ASTTL")=E=sum(ASSTr, AstPwrS(ASSTr));

** 20230606 

 InPwG_df(PwrG)..
   InvPwrG(PwrG) =E= PwrExp* PwgAst(PwrG, "InvLCS")*PG_LCS_S(PwrG)
                                 * PG_Adj(PwrG)*PwgX_Adj(PwrG);


 CapPwr50_df(PwrG).. CapPwr50(PwrG)=E=
   PwgAst(PwrG, "RsdRt")*PwgAst(PwrG, "Cap2015")+InvPwrG(PwrG)*Yftr;

 OutPwr50_df(PwrG).. OutPwr50(PwrG)=E=
   CapPwr50(PwrG)/(1e-6+PwgAst(PwrG, "Cap2015"))*PwgAst(PwrG, "Out2015")
     *PwgAst(PwrG, "CpUtlR")*PG_LCS_S(PwrG);


Table EFCinv15(i_TL, PwrS)
$call=xls2gms r=C1891:J2039 i=IO2015_135_2050_Dat.xlsx o=EFCiX.inc
$include EFCiX.inc
;


Table ElcMIO15(i_TL, PwrS)
$call=xls2gms r=C2043:J2191 i=IO2015_135_2050_Dat.xlsx o=MIOELX.inc
$include MIOELX.inc
;

Table ELCCpf15(i, PwrS)
$call=xls2gms r=C2197:K2247 i=IO2015_135_2050_Dat.xlsx o=ELcCpfX.inc
$include ElcCpfX.inc
;

ElcInvT(PWRS)=Sum(i, ELCCpf15(i, PwrS) );

Parameter EFCRTO(PwrS)
/
NCR     0.044729637
 Frd    0.117744495
 HYD    0.257618359
 Sol    0.361738532
 WND    0.352361707
 RNW    0.153823984
 TRD    0.429650883
/;

Equations
 EFC_XIJ_df(i)
 EFC_TVD_df

* 20220802

 EF_XR_df

;

 EFC_XIJ_df(i_15).. Ex_XAIJ(i_15, "EFC")=E=
   sum(PwrSg,
        EFCinv15(i_15, PwrSg)/(1e-6+EFCinv15("Q_Row_T", PwrSg))
        *EFCRTO(PwrSg)
        *sum(PwrG, CNV_GS(PwrSg, PwrG)* PwgAst(PwrG, "BldCst")*InvPwrG(PwrG)/1e3)
   )

 +     EFCinv15(i_15, "TRD")/(1e-6+EFCinv15("Q_Row_T", "TRD"))
     * EFCRTO("TRD")*InvPwrS("TRDS")
;

** 20230422 modified

 EFC_TVD_df.. Ex_Tvad("EFC")=E=

     X_CLM("EFC")*P_CLM("EFC") - sum(i_15, P_ROW(i_15)*Ex_XAIJ(i_15, "EFC"))
   -sum(i_50, P_ROW(i_50)*XAIJ(i_50, "EFC"));

*   sum(Pwrs,
*        EFCinv15("Vad_T", PwrS)/(1e-6+EFCinv15("Q_Row_T", PwrS))
*       *EFCRTO(PwrS)
*        *sum(PwrG, CNV_GS(PwrS, PwrG)* PwgAst(PwrG, "BldCst")*InvPwrG(PwrG)/1e3)
*  );


 EF_XR_df.. XAIJ("RaaS", "EFC")=E=Wge_Ras_RTE("EFC")*Ex_Tvad("EFC");

Equations
 ELC_XIJ_df(i)
 ELC_TVD_df

* modified 20220704

 ELC_Ful_df(i_FOS)

* 20220802 for RaaS

 EL_XR_df
;

 ELC_XIJ_df(i_NFOS)..   Ex_XAIJ(i_NFOS, "89")=E=
    LCSPwrGen(i_NFOS)*(
       sum(PwrSg,
               sum(PwrG, CNV_GS(PwrSg, PwrG)* OutPwr50(PwrG))
             /(1e-6+sum(PwrG, CNV_GS(PwrSg, PwrG)* PwgAst(PwrG, "Out2015")))
        *ElcMIO15(i_NFOS,PwrSg)
     )

    + ElcMIO15(i_NFOS,"TRD")*sum(PwrG,  OutPwr50(PwrG) )/sum(PwrG, PwgAst(PwrG, "Out2015"))
 )
;

 EL_XR_df..    XAIJ("RaaS", "89") =E= Wge_Ras_RTE("89")*Ex_Tvad("89");

* 20220704
 ELC_Ful_df(i_FOS)..
   Ex_XAIJ(i_FOS, "89")=E=
      sum(PwrG,  FOS_PwrG(i_FOS, PwrG)*OutPwr50(PwrG)*FulCst/1e3*LCSPwrGen(i_FOS));
 ELC_TVD_df..
   Ex_Tvad("89")=E= AstPwrS("ASTTL")*CapCstRt/EX_VadSH("Rtrn", "89");

Equations
 ELC_Cpf_df(i)
 EFC_Cpf_df(i);

Parameters
 ElCpf_i(PwrS);

 ElCpf_i(PwrS)=sum(i, ELCCpf15(i, PwrS));

 ELC_Cpf_df(i).. Ex_Cpf(i, "89")=E=
      sum(PwrSg, ELCCpf15(i, PwrSg)/ElcInvT(PWRSg)*CstDwn(i, PwrSg)
         *sum(PwrG, CNV_GS(PwrSg, PwrG)* PwgAst(PwrG, "BldCst")*InvPwrG(PwrG)/1e3)
      )

       + InvPwrS("TRDS")/ElCpf_i("TRD")*ELCCpf15(i, "TRD")
       + InvPwrS("BSNS")/ElCpf_i("BUS")*ELCCpf15(i, "BUS")
;

 EFC_Cpf_df(i).. Ex_Cpf(i, "EFC")
           =E= CpfMtx(i,"EFC")*Ex_Cpf("EFC", "89") /CpfMtx("EFC","89");


Equations
 ElcInv_df(j)
;

 ElcInv_df(j_EL).. Invst(j_EL) =E= sum(i, Ex_Cpf(i, j_EL) );

*======================================================================

** 2020 12 12 convergence of relative price
** 2021 4 15

VAIO_0(i,j)=VAIO_ORG(i,j);
PCLM_wrk0(j)=sum(i, vaio_ORG(i,j)*PNT_R(i))+1;

PCLM_wrk1(j)=sum(i, vaio(i,j)*PNT_R(i))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

P_clmW(j)=P_CLM(j)

display PCLM_wrk0, PCLM_wrk1, P_CLM, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

*======================

model IO_ftr2_Xt /all/;

solve IO_ftr2_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-5 : LCS scenario for Power generation  : Power sector investment by factor",PwrExp.L:15:5/;

$include IOMDL_OUT_S135B.gms


** Step-6 Iron and steel industry for 2050
* modified 20201201  -> should be completely modified in 133 model
* 50% steel -> elf
* 20220715 Direct Reduction Iron-Steel method

* Vad_SLK.FX(j)=Vad_SLK.L(j);
* DcrExp.FX(i)=DcrExp.L(i);

 Wgt_Xtr=0.5;

solve IO_ftr2_Xt maximizing OBJ_Xtr using NLP;

Parameter
 AIO_DRI(i_TL)
/
$call=xls2gms r=C2948:D3095 i=IO2015_135_2050_Dat.xlsx o=DRIIRNX.inc
$include DRIIRNX.inc
/
;

Parameter VAIO_DRI(i);

VAIO_DRI(i)=AIO_DRI(i)/AIO_DRI("Q_ROW_T");

Scalars
 DRIPRC /1.48821299/
 DRIshr /0.666/
;

AIO(i_TL, "45")=(1-DRIshr)*AIO(i_TL, "45") + DRIshr*AIO_DRI(i_TL);
VAIO(i, "45")=(1-DRIshr)*VAIO(i, "45") + DRIshr*VAIO_DRI(i);

PNT_R("45")=(1-DRIshr)*1.0 + DRIprc*DRIshr;

Parameter
 AIO_DRS(i_TL)
/
$call=xls2gms r=C3101:D3248 i=IO2015_135_2050_Dat.xlsx o=DRSSTLX.inc
$include DRSSTLX.inc
/
;

Parameter VAIO_DRS(i);

VAIO_DRS(i)=AIO_DRS(i)/AIO_DRS("Q_ROW_T");

Scalars
 DRSPRC /1.448646401/
;

AIO(i_TL, "46")=(1-DRIshr)*AIO(i_TL, "46") + DRIshr*AIO_DRS(i_TL);
VAIO(i, "46")=(1-DRIshr)*VAIO(i, "46") + DRIshr*VAIO_DRS(i);

PNT_R("46")=(1-DRIshr)*1.0 + DRSprc*DRIshr;

parameter AIO_CR(i,j),VAIO_CR(i,j);

Parameter DRI_CPF(i)
/
$call=xls2gms r=C3266:D3315 i=IO2015_135_2050_Dat.xlsx o=DRI_CPFX.inc
$include DRI_CPFX.inc
/
;

CpfMtx(i,"45")=(1-DRIshr)*CpfMtx(i, "45") + DRIshr*DRI_CPF(i);
CpfMtx(i,"46")=(1-DRIshr)*CpfMtx(i, "46") + DRIshr*CpfMtx(i, "47");

 Scalars
   ShrBfr /0.5/
   PrcBlf /0.054833/
   PrcElf /0.061574/

   StlExUp /1.1/;

set j_ElfP(j) /48*51/
    i_StlP(i) /46*51/
;

AIO_CR(i,j)=AIO(i,j);
VAIO_CR(i,j)=VAIO(i,j);

AIO_CR("46",j_ElfP)=ShrBfr*(AIO("46",j_ElfP)/PrcBlf+AIO("47",j_ElfP)/PrcElf)*PrcBlf;
AIO_CR("47",j_ElfP)=(1-ShrBfr)*(AIO("46",j_ElfP)/PrcBlf+AIO("47",j_ElfP)/PrcElf)*PrcElf;

VAIO_CR("46",j_ElfP)=ShrBfr*(VAIO("46",j_ElfP)/PrcBlf+VAIO("47",j_ElfP)/PrcElf)*PrcBlf;
VAIO_CR("47",j_ElfP)=(1-ShrBfr)*(VAIO("46",j_ElfP)/PrcBlf+VAIO("47",j_ElfP)/PrcElf)*PrcElf;

AIO(i,j)=AIO_CR(i,j);
VAIO(i,j)=VAIO_CR(i,j);

FD_CPf.LO(i_SCRP, "CPf_Oth")=  MIO(i_SCRP, "FND_T")*0.1;
FD_CPf.UP(i_SCRP, "CPf_Oth")=- MIO(i_SCRP, "FND_T")*0.1;

** 20220705 remove upper bound on electric furnace

X_im.UP("47")=X_im.L("47")*1.1;
X_Row.UP("47")=X_Row.L("46")+X_Row.L("47");

X_ex.up(i_StlP)=X_ex.L(i_StlP)*StlExUp;

* ImpUp=0.0;

solve IO_ftr2_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-6 : 50% Elctric furnace share, DRI share 66%, EV, ZEH, CEV and MaaS for mobility : Power sector investment by factor",PwrExp.L:15:5/;

$include IOMDL_OUT_S135B.gms

* $EXIT

*==== Step-7 industry sector electrification and H2 for 2050
**  moved from Step-3 to Step-7
** elctrification for industry sectors 20201205
** 20220703 flexibility in Oil products added
*  20220723 share of FR-FCV in roadl transportation sector

Scalar
 FRFCV_Sh /0.5/
 FRFCV_ER
;

* diesel ICE 40% eff FC eff 60%  motor eff 95%

 FRFCV_ER=0.40/0.6*0.95;

  x_ex.UP("35_d")=MIO("35_d","Exp")*2.0;

  X_ex.UP("36")=INF;
  X_ex.UP("40")=INF;

YldVR.UP("35_b")=   YldOP_UP*MIO("35_b","Q_Clm_T");
YldVR.LO("35_b")= - YldOP_UP*MIO("35_b","Q_Clm_T");

YldVR.UP("35_c")=   YldOP_UP*MIO("35_c","Q_Clm_T");
YldVR.LO("35_c")= - YldOP_UP*MIO("35_c","Q_Clm_T");

YldVR.UP("35_d")=   YldOP_UP*MIO("35_d","Q_Clm_T");
YldVR.LO("35_d")= - YldOP_UP*MIO("35_d","Q_Clm_T");

YldVR.UP("35_e")=   YldOP_UP*MIO("35_e","Q_Clm_T");
YldVR.LO("35_e")= - YldOP_UP*MIO("35_e","Q_Clm_T");

YldVR.UP("35_h")=   YldOP_UP*MIO("35_h","Q_Clm_T");
YldVR.LO("35_h")= - YldOP_UP*MIO("35_h","Q_Clm_T");

 FD_CPF.UP("36", "CPF_OTH")=INF;

* LY.LO(j)$(LY.L(j) eq LY.LO(j))=LY.L(j)*0.333;
* Invst.LO(j)$(Invst.LO(j) eq Invst.L(j))=Invst.L(j)*0.5;

** 20220723 for H2 production

 IntrVad("H2")=1;
 Y_vad.LO(vad, "H2")=0.0;
 Y_vad.UP(vad, "H2")=INF;

 X_row.UP("H2")=INF;
 X_clm.UP("H2")=INF;
 XAIJ.UP(i_15, "H2")=INF;
 XAIJ.LO(i, "H2")=0.0;

 XAIJ.UP("H2",j_15)=INF;
  XAIJ.UP("H2",j)=INF;
* XAIJ.LO("H2",j)=-INF;

 LY.UP("H2")=Lbr_i("90")*2.0;
 KY.UP("H2")=K0("90")*10.0;
 Invst.UP("H2")=Invst_i("90")*10.0;

 LY.L("H2")=LY.L("90")*0.1;
 KY.L("H2")=KY.L("90")*0.1;
 Invst.L("H2")=Invst.L("90")*0.1;
 T_Vad.L("H2")=T_Vad.L("90")*0.1;

 XAIJ.L(i, "H2")=XAIJ.L(i, "90")*0.1;

display AY, BY, k0, Lbr_i, PKY, PLY;


Parameter AIO_St6(i_TL,j), VAIO_St6(i,j);
 AIO_St6(i_TL,j)=AIO(i_TL,j);
 VAIO_St6(i, j)=VAIO(i,j);

* electrification and hydrogen share 33% -> 75%

* Sh_Elfy=0.3333;
 Sh_Elfy=0.75;
 R_Elfy(j)=Sh_Elfy;

* 20220807 naphtha removed from fuel

sets
  i_fuel(i) /6a, 6b, 6c, 14, 35_a, 35_b,35_c,35_d,35_e,35_f, 35_h, 35_i, 36, 90/
  i_Ngas(i_fuel) /6a, 6b, 14, 35_a, 35_b,35_c,35_d,35_e,35_f, 35_h, 35_i, 36/

  i_HPheat(i_fuel) /35_c, 35_h, 90/
  i_HPhtng(i_fuel) /35_c, 35_h/
  i_ElMot(i_fuel)  /35_a, 35_b, 35_d/
  i_Boil(i_fuel)   /6a, 6b, 6c, 35_e, 35_f, 36/
  i_Hydro(i_fuel)  /6c, 90/

  j_H2Burn(j_Elfy)  /8*18, 37*43, 53*77, 80*88, EFC/
  j_HPheat(j_Elfy) /1*5,6a,6b,6c,7a,7b, 91*98, 102*128/

  i_OlPS(i_fuel) /35_a, 35_b,35_c,35_d,35_e,35_f, 35_h, 35_i/
;

* fuel cost Yen per MJ

Parameter EFulCst(i)
/
$call=xls2gms r=C2891:D2905 i=IO2015_135_2050_Dat.xlsx o=EFULCSTX.inc
$include EFULCSTX.inc
/;

Scalars
  ElcPrc /6.297/
  H2Prc  /7.420/
  WdChpPRc /0.720/
;

set F_Use /APGnr, StmGnr, FnlUse/;

Scalars
   HPCOP        /3.8/
   ICEeff       /0.35/
   Moteff       /0.9/
   BoiLeff      /0.9/
   APGReff      /0.38/
   WdBoleff     /0.75/
;

** relax products yields

Scalar OilAdj /0.025/;

X_FLX.UP(i_OPs)=  MIO(i_OPs, "Q_Clm_T")*OilAdj;
X_FLX.LO(i_OPs)=- MIO(i_OPs, "Q_Clm_T")*OilAdj;

x_ex.UP("35_e")=X_im.L("6b");

* + sum(i_OlPs, x_im.L(i_OlPs));

Equation OilPrdBl;
  OilPrdBl.. sum(i_OlPs, X_FLX(i_OlPs)/EFulCst(i_OlPs))=E=0.0;


* Fuel use share
Table FulUSEShr(i_Fuel, F_Use, j)

$call=xls2gms r=C2919:EE2943 i=IO2015_135_2050_Dat.xlsx o=FulUseSX.inc
$include FulUseSX.inc
;

Vaio(i_fuel, j_elfy)=Vaio_st6(i_fuel, j_elfy)*(1.0-R_Elfy(j_elfy));
Aio(i_fuel, j_elfy)=Aio_st6(i_fuel, j_elfy)*(1.0-R_Elfy(j_elfy));

* conv autoproducer to utility

 Vaio("89", j_elfy)=Vaio_st6("89", j_elfy)+
   sum(i_fuel,  R_Elfy(j_elfy)*Vaio_st6(i_fuel, j_elfy)
          *FulUSEShr(i_Fuel,"APGnr", j_elfy)/EFulCst(i_fuel)*APGReff*ElcPRC );

 Aio("89", j_elfy)=AIO_st6("89", j_elfy)+
   sum(i_fuel,  R_Elfy(j_elfy)*AIO_st6(i_fuel, j_elfy)
          *FulUSEShr(i_Fuel,"APGnr", j_elfy)/EFulCst(i_fuel)*APGReff*ElcPRC );

* conv heatingr to HP manufacturings and others separated

 Vaio("89", j_HPheat)=Vaio("89", j_HPheat)+
   sum(i_HPheat,  R_Elfy(j_HPheat)*Vaio_st6(i_HPheat, j_HPheat)
          *FulUSEShr(i_HPheat,"FnlUse", j_HPheat)/EFulCst(i_HPheat)*Boileff/HPCOP*ElcPRC );
 
 AIO("89", j_HPheat)=AIO("89", j_HPheat)+
   sum(i_HPheat,  R_Elfy(j_HPheat)*AIO_st6(i_HPheat, j_HPheat)
          *FulUSEShr(i_HPheat,"FnlUse", j_HPheat)/EFulCst(i_HPheat)*Boileff/HPCOP*ElcPRC );

 Vaio("89", j_H2burn)=Vaio("89", j_H2burn)+
   sum(i_HPhtng,  R_Elfy(j_H2burn)*Vaio_st6(i_HPhtng, j_H2burn)
          *FulUSEShr(i_HPhtng, "FnlUse", j_H2burn)/EFulCst(i_HPhtng)*Boileff/HPCOP*ElcPRC );

 Aio("89", j_H2burn)=Aio("89", j_H2burn)+
   sum(i_HPhtng,  R_Elfy(j_H2burn)*Aio_st6(i_HPhtng, j_H2burn)
          *FulUSEShr(i_HPhtng, "FnlUse", j_H2burn)/EFulCst(i_HPhtng)*Boileff/HPCOP*ElcPRC );

* conv ICE to motor

 Vaio("89", j_Elfy)=Vaio("89", j_Elfy)+
   sum(i_ElMot,  R_Elfy(j_Elfy)*Vaio_st6(i_ElMot, j_Elfy)
          *FulUSEShr(i_Elmot,"FnlUse", j_Elfy)/EFulCst(i_Elmot)*Iceeff/MotEff*ElcPRC );
 
 AIO("89", j_Elfy)=AIO("89", j_Elfy)+
   sum(i_ElMot,  R_Elfy(j_Elfy)*AIO_st6(i_ElMot, j_Elfy)
          *FulUSEShr(i_Elmot,"FnlUse", j_Elfy)/EFulCst(i_Elmot)*Iceeff/MotEff*ElcPRC );

* conv fuel for boiler and steam to woodchip

 Vaio("14", j_elfy)=Vaio_st6("14", j_elfy)+
   sum(i_fuel,  R_Elfy(j_elfy)*Vaio_st6(i_fuel, j_elfy)
          *FulUSEShr(i_Fuel,"StmGnr", j_elfy)/EFulCst(i_fuel)*Boileff/WdBolEff*WdChpPRc )

  + sum(i_Boil, R_Elfy(j_elfy)*Vaio_st6(i_boil, j_elfy)
          *FulUSEShr(i_boil,"FnlUse", j_elfy)/EFulCst(i_Boil)*Boileff/WdBolEff*WdChpPRc );

 Aio("14", j_elfy)=Aio_st6("14", j_elfy)+
   sum(i_fuel,  R_Elfy(j_elfy)*Aio_st6(i_fuel, j_elfy)
          *FulUSEShr(i_Fuel,"StmGnr", j_elfy)/EFulCst(i_fuel)*Boileff/WdBolEff*WdChpPRc )

  + sum(i_Boil, R_Elfy(j_elfy)*Aio_st6(i_boil, j_elfy)
          *FulUSEShr(i_boil,"FnlUse", j_elfy)/EFulCst(i_Boil)*Boileff/WdBolEff*WdChpPRc );

* conv manufacturing gas to hydrogen

 Vaio("H2", j_H2burn)= sum(i_Hydro, R_Elfy(j_H2burn)*Vaio_st6(i_Hydro, j_H2burn)
          *FulUSEShr(i_Hydro,"FnlUse", j_H2burn)/EFulCst(i_Hydro)*H2PRC);

 Aio("H2", j_H2burn)= sum(i_Hydro, R_Elfy(j_H2burn)*Aio_st6(i_Hydro, j_H2burn)
          *FulUSEShr(i_Hydro,"FnlUse", j_H2burn)/EFulCst(i_Hydro)*H2PRC );

* conv freightt tranportation kerosene to hydrogen

Vaio("35_d", "99")=Vaio_St6("35_d", "99")*(1-FRFCV_Sh);
Aio("35_d", "99")=Vaio_st6("35_d", "99")*(1-FRFCV_Sh);

Vaio("H2", "99")=Vaio("H2", "99")+Vaio_st6("35_d", "99")*FRFCV_Sh*FRFCV_ER/EFulCst("35_d")*H2PRC;
Aio("H2", "99")=Vaio("H2", "99")+Aio_st6("35_d", "99")*FRFCV_Sh*FRFCV_ER/EFulCst("35_d")*H2PRC;

display vaio;

Equation H2XAIJ_df(j);

 H2XAIJ_df(j)..
      XAIJ("H2",j) =E= IntrVad(j)*T_vad(j)*VAIO("H2",j)*PNT_R("H2")
                           +(1-IntrVad(j))*Ex_XAIJ("H2",j);

* 20210421
* PNT_R("H2")= H2_CG_Rto*Gs_Ind_Sh;

** FR-FCV input-output coeffs Hino Profia

Parameter AIO_FRFCV(i_TL)
/
$call=xls2gms r=C3320:D3466 i=IO2015_135_2050_Dat.xlsx o=EFULCSTX.inc
$include EFULCSTX.inc
/;

Scalar PiFRFCV /1.01817037/;

parameter VAIO_FRFCV(i_TL);
 VAIO_FRFCV(i_TL)=AIO_FRFCV(i_TL)/AIO_FRFCV("VAD_T");

Vaio(i, "79")=FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh)*VAIO_FRFCV(i)
             +(1-FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh))*Vaio(i,"79");

Aio(i_TL, "79")=FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh)*AIO_FRFCV(i_TL)
             +(1-FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh))*Aio(i_TL,"79");

** 2020 12 12 convergence of relative price

VAIO_0(i,j)=VAIO_ORG(i,j);
PCLM_wrk0(j)=sum(i, vaio_ORG(i,j)*PNT_R(i))+1;

PCLM_wrk1(j)=sum(i, vaio(i,j)*PNT_R(i))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

P_clmW(j)=P_CLM(j)

display PCLM_wrk0, PCLM_wrk1, P_CLM, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));


solve IO_ftr2_Xt maximizing OBJ_Xtr using NLP;

*======================
Model IO_Ftr3_Xt /All/;

solve IO_ftr3_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-7 : 50% Elctric furnace share, 66% DRI share of rest, 75% industry decarbonization, EV, ZEH, CEV and MaaS for mobility : Power sector investment by factor",PwrExp.L:15:5/;

$include IOMDL_OUT_S135B.gms


*==== Step-8 more expanded decarbonization industry sector electrification and H2 for 2050
**  moved from Step-3 to Step-7
** elctrification for industry sectors 20201205
** 20220703 flexibility in Oil products added
*  20220723 share of FR-FCV in roadl transportation sector
*  20220807 including electrification of households

 Sh_Elfy=0.85;
 R_Elfy(j)=Sh_Elfy;


 FRFCV_Sh=0.8;

* conv freightt tranportation kerosene to hydrogen

Vaio("35_d", "99")=Vaio_St6("35_d", "99")*(1-FRFCV_Sh);
Aio("35_d", "99")=Vaio_st6("35_d", "99")*(1-FRFCV_Sh);

Vaio("H2", "99")=Vaio("H2", "99")+Vaio_st6("35_d", "99")*FRFCV_Sh*FRFCV_ER/EFulCst("35_d")*H2PRC;
Aio("H2", "99")=Vaio("H2", "99")+Aio_st6("35_d", "99")*FRFCV_Sh*FRFCV_ER/EFulCst("35_d")*H2PRC;

Vaio(i, "79")=FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh)*VAIO_FRFCV(i)
             +(1-FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh))*Vaio(i,"79");

Aio(i_TL, "79")=FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh)*AIO_FRFCV(i_TL)
             +(1-FRFCV_Sh*PiFRFCV/(FRFCV_Sh*PiFRFCV+1-FRFCV_Sh))*Aio(i_TL,"79");
Parameter Sh_SrsbS7(Rsb)
/
Old     0.1
ZEHrd   0.8109
ZEH     0.0891
/;

Sh_Srsb(Rsb)=Sh_SrsbS7(Rsb);

Parameter Sh_NrsbS7(Rsb)
/
Old     0.01
ZEHrd   0.54
ZEH     0.45
/
;

Sh_Nrsb(Rsb)= Sh_NrsbS7(Rsb);

Csp_Ftr("89")=
 MIO("89", "Csp_Prv") * PFD_Csp("89", "Csp_Prv") *
  ( (1.0-NwSt_Rto)*sum(Rsb, ElcRtio(Rsb)*Sh_Srsb(Rsb))
   + NwSt_Rto*sum(Rsb, ElcRtio(Rsb)*Sh_Nrsb(Rsb)));

Csp_Ftr(i_HhFl)=
 MIO(i_HhFl, "Csp_Prv") * PFD_Csp(i_HhFl, "Csp_Prv") *
  ( (1.0-NwSt_Rto)*sum(Rsb, GasRtio(Rsb)*Sh_Srsb(Rsb))
   + NwSt_Rto*sum(Rsb, GasRtio(Rsb)*Sh_Nrsb(Rsb)));

CpfCof(i,"97")=Sum(Rsb, Sh_Nrsb(Rsb)*CpCof_H(i, Rsb)*PI_rsb(Rsb)) *PNT_R(i);

FD_CSP.LO(i_HhFl, "Csp_Prv")=0.0;

 x_ex.up("90")=x_ex.up("90")*3.0;

Invst.LO("90")=Invst.L("90")*0.1;

* electrification and hydrogen share 33% -> 75%
* expansion of j_Elfy

set
  j_elfy2(j) /1*5,6a,6b,6c,7a,7b,8*34, 37*43, 48*88, EFC, 91*98, 102*128/
  j_H2Bn2(j_Elfy2)  /8*18, 37*43,  53*77, 80*88, EFC/
  j_HPht2(j_Elfy2)  /1*5,6a,6b,6c,7a,7b, 91*98, 102*128/
  j_ElcHt(j_Elfy2)   /19*34, 48*52, 78,79/
;

scalar ElcHteff     /0.97/;

Vaio(i_fuel, j_elfy2)=Vaio_st6(i_fuel, j_elfy2)*(1.0-R_Elfy(j_elfy2));
Aio(i_fuel, j_elfy2)=Aio_st6(i_fuel, j_elfy2)*(1.0-R_Elfy(j_elfy2));

* conv autoproducer to utility

 Vaio("89", j_Elfy2)=Vaio_st6("89", j_Elfy2)+
   sum(i_fuel,  R_Elfy(j_Elfy2)*Vaio_st6(i_fuel, j_Elfy2)
          *FulUSEShr(i_Fuel,"APGnr", j_Elfy2)/EFulCst(i_fuel)*APGReff*ElcPRC );

 Aio("89", j_Elfy2)=AIO_st6("89", j_Elfy2)+
   sum(i_fuel,  R_Elfy(j_Elfy2)*AIO_st6(i_fuel, j_Elfy2)
          *FulUSEShr(i_Fuel,"APGnr", j_Elfy2)/EFulCst(i_fuel)*APGReff*ElcPRC );

* conv heatingr to HP manufacturings and others separated

 Vaio("89", j_HPht2)=Vaio("89", j_HPht2)+
   sum(i_HPheat,  R_Elfy(j_HPht2)*Vaio_st6(i_HPheat, j_HPht2)
          *FulUSEShr(i_HPheat,"FnlUse", j_HPht2)/EFulCst(i_HPheat)*Boileff/HPCOP*ElcPRC );

 AIO("89", j_HPht2)=AIO("89", j_HPht2)+
   sum(i_HPheat,  R_Elfy(j_HPht2)*AIO_st6(i_HPheat, j_HPht2)
          *FulUSEShr(i_HPheat,"FnlUse", j_HPht2)/EFulCst(i_HPheat)*Boileff/HPCOP*ElcPRC );

 Vaio("89", j_H2Bn2)=Vaio("89", j_H2Bn2)+
   sum(i_HPhtng,  R_Elfy(j_H2Bn2)*Vaio_st6(i_HPhtng, j_H2Bn2)
          *FulUSEShr(i_HPhtng, "FnlUse", j_H2Bn2)/EFulCst(i_HPhtng)*Boileff/HPCOP*ElcPRC );

 Aio("89", j_H2Bn2)=Aio("89", j_H2Bn2)+
   sum(i_HPhtng,  R_Elfy(j_H2Bn2)*Aio_st6(i_HPhtng, j_H2Bn2)
          *FulUSEShr(i_HPhtng, "FnlUse", j_H2Bn2)/EFulCst(i_HPhtng)*Boileff/HPCOP*ElcPRC );

* conv ICE to motor

 Vaio("89", j_Elfy2)=Vaio("89", j_Elfy2)+
   sum(i_ElMot,  R_Elfy(j_Elfy2)*Vaio_st6(i_ElMot, j_Elfy2)
          *FulUSEShr(i_Elmot,"FnlUse", j_Elfy2)/EFulCst(i_Elmot)*Iceeff/MotEff*ElcPRC );

 AIO("89", j_Elfy2)=AIO("89", j_Elfy2)+
   sum(i_ElMot,  R_Elfy(j_Elfy2)*AIO_st6(i_ElMot, j_Elfy2)
          *FulUSEShr(i_Elmot,"FnlUse", j_Elfy2)/EFulCst(i_Elmot)*Iceeff/MotEff*ElcPRC );

* conv fuel burner to electric heater

 Vaio("89", j_ElcHt)=Vaio("89", j_ElcHt)+
   sum(i_Hydro,  R_Elfy(j_ElcHt)*Vaio_st6(i_Hydro, j_ElcHt)
          *FulUSEShr(i_Hydro, "FnlUse", j_ElcHt)/EFulCst(i_Hydro)/ElcHteff*ElcPRC );

 Aio("89", j_ElcHt)=Aio("89", j_ElcHt)+
   sum(i_Hydro,  R_Elfy(j_ElcHt)*Aio_st6(i_Hydro, j_ElcHt)
          *FulUSEShr(i_Hydro, "FnlUse", j_ElcHt)/EFulCst(i_Hydro)/ElcHteff*ElcPRC );

* conv fuel for boiler and steam to woodchip

 Vaio("14", j_Elfy2)=Vaio_st6("14", j_Elfy2)+
   sum(i_fuel,  R_Elfy(j_Elfy2)*Vaio_st6(i_fuel, j_Elfy2)
          *FulUSEShr(i_Fuel,"StmGnr", j_Elfy2)/EFulCst(i_fuel)*Boileff/WdBolEff*WdChpPRc )

  + sum(i_Boil, R_Elfy(j_Elfy2)*Vaio_st6(i_boil, j_Elfy2)
          *FulUSEShr(i_boil,"FnlUse", j_Elfy2)/EFulCst(i_Boil)*Boileff/WdBolEff*WdChpPRc );

 Aio("14", j_Elfy2)=Aio_st6("14", j_Elfy2)+
   sum(i_fuel,  R_Elfy(j_Elfy2)*Aio_st6(i_fuel, j_Elfy2)
          *FulUSEShr(i_Fuel,"StmGnr", j_Elfy2)/EFulCst(i_fuel)*Boileff/WdBolEff*WdChpPRc )

  + sum(i_Boil, R_Elfy(j_Elfy2)*Aio_st6(i_boil, j_Elfy2)
          *FulUSEShr(i_boil,"FnlUse", j_Elfy2)/EFulCst(i_Boil)*Boileff/WdBolEff*WdChpPRc );

* conv manufacturing gas to hydrogen

 Vaio("H2", j_H2Bn2)= sum(i_Hydro, R_Elfy(j_H2Bn2)*Vaio_st6(i_Hydro, j_H2Bn2)
          *FulUSEShr(i_Hydro,"FnlUse", j_H2Bn2)/EFulCst(i_Hydro)*H2PRC);

 Aio("H2", j_H2Bn2)= sum(i_Hydro, R_Elfy(j_H2Bn2)*Aio_st6(i_Hydro, j_H2Bn2)
          *FulUSEShr(i_Hydro,"FnlUse", j_H2Bn2)/EFulCst(i_Hydro)*H2PRC );

* conv freightt tranportation kerosene to hydrogen

Vaio("35_d", "99")=Vaio_St6("35_d", "99")*(1-FRFCV_Sh);
Aio("35_d", "99")=Vaio_st6("35_d", "99")*(1-FRFCV_Sh);

Vaio("H2", "99")=Vaio("H2", "99")+Vaio_st6("35_d", "99")*FRFCV_Sh*FRFCV_ER/EFulCst("35_d")*H2PRC;
Aio("H2", "99")=Vaio("H2", "99")+Aio_st6("35_d", "99")*FRFCV_Sh*FRFCV_ER/EFulCst("35_d")*H2PRC;


** FR-FCV input-output coeffs Hino Profia


VAIO_0(i,j)=VAIO_ORG(i,j);
PCLM_wrk0(j)=sum(i, vaio_ORG(i,j)*PNT_R(i))+1;

PCLM_wrk1(j)=sum(i, vaio(i,j)*PNT_R(i))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

P_clmW(j)=P_CLM(j)

display PCLM_wrk0, PCLM_wrk1, P_CLM, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_clmW(j)=P_CLM(j);
P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));

PCLM_wrk0(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio_0(i,j))+1;

PCLM_wrk1(j)=sum(i, PNT_R(i)*P_ROW(i)*vaio(i,j))+1;

P_CLM(j)=PCLM_wrk1(j)/PCLM_wrk0(j)*VAD_RTO(j);

pwrk=sum(j, (P_CLM(j)-P_CLMW(j))*(P_CLM(j)-P_CLMW(j)) );

display PCLM_wrk0, PCLM_wrk1, P_CLM, pwrk, VAD_RTO;

P_ROW(i)=sum(j, ijcnv2(i,j)*P_clm(j));


solve IO_ftr3_Xt maximizing OBJ_Xtr using NLP;

Put //;Put "Step-8 : Expanded decarobonization : Power sector investment by factor",PwrExp.L:15:5/;

$include IOMDL_OUT_S135B.gms



